(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_kotlinx_coroutines_core) {
  'use strict';
  //region block: imports
  var constructor = (class IteratorYieldResult {
    static [Symbol.hasInstance](instance) {
        return instance && (typeof instance === 'object') && (instance.done === false)
    }
    }.prototype).constructor;
  var VOID = kotlin_kotlin.$_$.d;
  var generateSequence = kotlin_kotlin.$_$.t5;
  var map = kotlin_kotlin.$_$.u5;
  var intercepted = kotlin_kotlin.$_$.y2;
  var CancellableContinuationImpl = kotlin_org_jetbrains_kotlinx_kotlinx_coroutines_core.$_$.a;
  var Unit_instance = kotlin_kotlin.$_$.v;
  var resume = kotlin_kotlin.$_$.f3;
  var resumeWithException = kotlin_kotlin.$_$.e3;
  //endregion
  //region block: pre-declaration
  //endregion
  function copy(_this__u8e3s4, hourCycle, second, timeZone, calendar, era, dateStyle, formatMatcher, day, localeMatcher, hour12, fractionalSecondDigits, month, hour, dayPeriod, weekday, minute, timeStyle, timeZoneName, year, numberingSystem) {
    hourCycle = hourCycle === VOID ? VOID : hourCycle;
    second = second === VOID ? VOID : second;
    timeZone = timeZone === VOID ? VOID : timeZone;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    dateStyle = dateStyle === VOID ? VOID : dateStyle;
    formatMatcher = formatMatcher === VOID ? VOID : formatMatcher;
    day = day === VOID ? VOID : day;
    localeMatcher = localeMatcher === VOID ? VOID : localeMatcher;
    hour12 = hour12 === VOID ? VOID : hour12;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    month = month === VOID ? VOID : month;
    hour = hour === VOID ? VOID : hour;
    dayPeriod = dayPeriod === VOID ? VOID : dayPeriod;
    weekday = weekday === VOID ? VOID : weekday;
    minute = minute === VOID ? VOID : minute;
    timeStyle = timeStyle === VOID ? VOID : timeStyle;
    timeZoneName = timeZoneName === VOID ? VOID : timeZoneName;
    year = year === VOID ? VOID : year;
    numberingSystem = numberingSystem === VOID ? VOID : numberingSystem;
    return Object.assign({}, _this__u8e3s4, {hourCycle: hourCycle, second: second, timeZone: timeZone, calendar: calendar, era: era, dateStyle: dateStyle, formatMatcher: formatMatcher, day: day, localeMatcher: localeMatcher, hour12: hour12, fractionalSecondDigits: fractionalSecondDigits, month: month, hour: hour, dayPeriod: dayPeriod, weekday: weekday, minute: minute, timeStyle: timeStyle, timeZoneName: timeZoneName, year: year, numberingSystem: numberingSystem});
  }
  function invoke(_this__u8e3s4, hourCycle, second, timeZone, calendar, era, dateStyle, formatMatcher, day, localeMatcher, hour12, fractionalSecondDigits, month, hour, dayPeriod, weekday, minute, timeStyle, timeZoneName, year, numberingSystem) {
    hourCycle = hourCycle === VOID ? VOID : hourCycle;
    second = second === VOID ? VOID : second;
    timeZone = timeZone === VOID ? VOID : timeZone;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    dateStyle = dateStyle === VOID ? VOID : dateStyle;
    formatMatcher = formatMatcher === VOID ? VOID : formatMatcher;
    day = day === VOID ? VOID : day;
    localeMatcher = localeMatcher === VOID ? VOID : localeMatcher;
    hour12 = hour12 === VOID ? VOID : hour12;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    month = month === VOID ? VOID : month;
    hour = hour === VOID ? VOID : hour;
    dayPeriod = dayPeriod === VOID ? VOID : dayPeriod;
    weekday = weekday === VOID ? VOID : weekday;
    minute = minute === VOID ? VOID : minute;
    timeStyle = timeStyle === VOID ? VOID : timeStyle;
    timeZoneName = timeZoneName === VOID ? VOID : timeZoneName;
    year = year === VOID ? VOID : year;
    numberingSystem = numberingSystem === VOID ? VOID : numberingSystem;
    return {hourCycle: hourCycle, second: second, timeZone: timeZone, calendar: calendar, era: era, dateStyle: dateStyle, formatMatcher: formatMatcher, day: day, localeMatcher: localeMatcher, hour12: hour12, fractionalSecondDigits: fractionalSecondDigits, month: month, hour: hour, dayPeriod: dayPeriod, weekday: weekday, minute: minute, timeStyle: timeStyle, timeZoneName: timeZoneName, year: year, numberingSystem: numberingSystem};
  }
  function copy_0(_this__u8e3s4, maxByteLength) {
    maxByteLength = maxByteLength === VOID ? VOID : maxByteLength;
    return Object.assign({}, _this__u8e3s4, {maxByteLength: maxByteLength});
  }
  function invoke_0(_this__u8e3s4, maxByteLength) {
    return {maxByteLength: maxByteLength};
  }
  function get_POW() {
    _init_properties_BigInt_kt__agomkx();
    return POW;
  }
  var POW;
  function get_n(_this__u8e3s4) {
    _init_properties_BigInt_kt__agomkx();
    return BigInt(_this__u8e3s4);
  }
  var properties_initialized_BigInt_kt_nhzooh;
  function _init_properties_BigInt_kt__agomkx() {
    if (!properties_initialized_BigInt_kt_nhzooh) {
      properties_initialized_BigInt_kt_nhzooh = true;
      POW = Function('base', 'exponent', 'return base ** exponent');
    }
  }
  function invoke_1(_this__u8e3s4, p1, p2) {
    // Inline function 'js.reflect.unsafeCast' call
    // Inline function 'kotlin.js.unsafeCast' call
    // Inline function 'kotlin.js.asDynamic' call
    return _this__u8e3s4(p1, p2);
  }
  function iteratorFromJsIterable(source) {
    // Inline function 'js.iterable.JsIterator.iterator' call
    var this_0 = source[Symbol.iterator]();
    return iteratorFromJsIteratorLike(this_0);
  }
  function iteratorFromJsIteratorLike(source) {
    var tmp = generateSequence(iteratorFromJsIteratorLike$lambda(source));
    return map(tmp, iteratorFromJsIteratorLike$lambda_0).x();
  }
  function iteratorFromJsIteratorLike$lambda($source) {
    return function () {
      var tmp = $source.next();
      return tmp instanceof constructor ? tmp : null;
    };
  }
  function iteratorFromJsIteratorLike$lambda_0(it) {
    return it.value;
  }
  function copy_1(_this__u8e3s4, enumerable, value, get, writable, set, configurable) {
    enumerable = enumerable === VOID ? VOID : enumerable;
    value = value === VOID ? VOID : value;
    get = get === VOID ? VOID : get;
    writable = writable === VOID ? VOID : writable;
    set = set === VOID ? VOID : set;
    configurable = configurable === VOID ? VOID : configurable;
    return Object.assign({}, _this__u8e3s4, {enumerable: enumerable, value: value, get: get, writable: writable, set: set, configurable: configurable});
  }
  function invoke_2(_this__u8e3s4, enumerable, value, get, writable, set, configurable) {
    enumerable = enumerable === VOID ? VOID : enumerable;
    value = value === VOID ? VOID : value;
    get = get === VOID ? VOID : get;
    writable = writable === VOID ? VOID : writable;
    set = set === VOID ? VOID : set;
    configurable = configurable === VOID ? VOID : configurable;
    return {enumerable: enumerable, value: value, get: get, writable: writable, set: set, configurable: configurable};
  }
  function awaitPromiseLike(promise, $completion) {
    // Inline function 'kotlinx.coroutines.suspendCancellableCoroutine.<anonymous>' call
    var cancellable = new CancellableContinuationImpl(intercepted($completion), 1);
    cancellable.p1a();
    // Inline function 'js.promise.internal.awaitPromiseLike.stub_for_inlining' call
    thenToContinuation(promise, cancellable);
    return cancellable.a1b();
  }
  function thenToContinuation(promise, continuation) {
    var tmp = resume$ref(continuation);
    promise.then(tmp, resumeWithException$ref(continuation));
  }
  function resume$ref($boundThis) {
    var l = function (p0) {
      resume($boundThis, p0);
      return Unit_instance;
    };
    l.callableName = 'resume';
    return l;
  }
  function resumeWithException$ref($boundThis) {
    var l = function (p0) {
      resumeWithException($boundThis, p0);
      return Unit_instance;
    };
    l.callableName = 'resumeWithException';
    return l;
  }
  function copy_2(_this__u8e3s4, overflow) {
    overflow = overflow === VOID ? VOID : overflow;
    return Object.assign({}, _this__u8e3s4, {overflow: overflow});
  }
  function invoke_3(_this__u8e3s4, overflow) {
    overflow = overflow === VOID ? VOID : overflow;
    return {overflow: overflow};
  }
  function copy_3(_this__u8e3s4, overflow) {
    overflow = overflow === VOID ? VOID : overflow;
    return Object.assign({}, _this__u8e3s4, {overflow: overflow});
  }
  function invoke_4(_this__u8e3s4, overflow) {
    overflow = overflow === VOID ? VOID : overflow;
    return {overflow: overflow};
  }
  function copy_4(_this__u8e3s4, era, eraYear, year, month, monthCode, day) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    day = day === VOID ? VOID : day;
    return Object.assign({}, _this__u8e3s4, {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode, day: day});
  }
  function invoke_5(_this__u8e3s4, era, eraYear, year, month, monthCode, day) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode, day: day};
  }
  function copy_5(_this__u8e3s4, era, eraYear, year, month, monthCode) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return Object.assign({}, _this__u8e3s4, {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode});
  }
  function invoke_6(_this__u8e3s4, era, eraYear, year, month, monthCode) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode};
  }
  function copy_6(_this__u8e3s4, era, eraYear, year, month, monthCode, day) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    day = day === VOID ? VOID : day;
    return Object.assign({}, _this__u8e3s4, {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode, day: day});
  }
  function invoke_7(_this__u8e3s4, era, eraYear, year, month, monthCode, day) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode, day: day};
  }
  function copy_7(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits, calendarName) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    calendarName = calendarName === VOID ? VOID : calendarName;
    return Object.assign({}, _this__u8e3s4, {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits, calendarName: calendarName});
  }
  function invoke_8(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits, calendarName) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    calendarName = calendarName === VOID ? VOID : calendarName;
    return {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits, calendarName: calendarName};
  }
  function copy_8(_this__u8e3s4, roundingIncrement, smallestUnit, roundingMode, largestUnit) {
    roundingIncrement = roundingIncrement === VOID ? VOID : roundingIncrement;
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    largestUnit = largestUnit === VOID ? VOID : largestUnit;
    return Object.assign({}, _this__u8e3s4, {roundingIncrement: roundingIncrement, smallestUnit: smallestUnit, roundingMode: roundingMode, largestUnit: largestUnit});
  }
  function invoke_9(_this__u8e3s4, roundingIncrement, smallestUnit, roundingMode, largestUnit) {
    roundingIncrement = roundingIncrement === VOID ? VOID : roundingIncrement;
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    largestUnit = largestUnit === VOID ? VOID : largestUnit;
    return {roundingIncrement: roundingIncrement, smallestUnit: smallestUnit, roundingMode: roundingMode, largestUnit: largestUnit};
  }
  function copy_9(_this__u8e3s4, relativeTo) {
    relativeTo = relativeTo === VOID ? VOID : relativeTo;
    return Object.assign({}, _this__u8e3s4, {relativeTo: relativeTo});
  }
  function invoke_10(_this__u8e3s4, relativeTo) {
    relativeTo = relativeTo === VOID ? VOID : relativeTo;
    return {relativeTo: relativeTo};
  }
  function copy_10(_this__u8e3s4, microseconds, milliseconds, days, nanoseconds, months, hours, minutes, years, seconds, weeks) {
    microseconds = microseconds === VOID ? VOID : microseconds;
    milliseconds = milliseconds === VOID ? VOID : milliseconds;
    days = days === VOID ? VOID : days;
    nanoseconds = nanoseconds === VOID ? VOID : nanoseconds;
    months = months === VOID ? VOID : months;
    hours = hours === VOID ? VOID : hours;
    minutes = minutes === VOID ? VOID : minutes;
    years = years === VOID ? VOID : years;
    seconds = seconds === VOID ? VOID : seconds;
    weeks = weeks === VOID ? VOID : weeks;
    return Object.assign({}, _this__u8e3s4, {microseconds: microseconds, milliseconds: milliseconds, days: days, nanoseconds: nanoseconds, months: months, hours: hours, minutes: minutes, years: years, seconds: seconds, weeks: weeks});
  }
  function invoke_11(_this__u8e3s4, microseconds, milliseconds, days, nanoseconds, months, hours, minutes, years, seconds, weeks) {
    microseconds = microseconds === VOID ? VOID : microseconds;
    milliseconds = milliseconds === VOID ? VOID : milliseconds;
    days = days === VOID ? VOID : days;
    nanoseconds = nanoseconds === VOID ? VOID : nanoseconds;
    months = months === VOID ? VOID : months;
    hours = hours === VOID ? VOID : hours;
    minutes = minutes === VOID ? VOID : minutes;
    years = years === VOID ? VOID : years;
    seconds = seconds === VOID ? VOID : seconds;
    weeks = weeks === VOID ? VOID : weeks;
    return {microseconds: microseconds, milliseconds: milliseconds, days: days, nanoseconds: nanoseconds, months: months, hours: hours, minutes: minutes, years: years, seconds: seconds, weeks: weeks};
  }
  function copy_11(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits, timeZone) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    timeZone = timeZone === VOID ? VOID : timeZone;
    return Object.assign({}, _this__u8e3s4, {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits, timeZone: timeZone});
  }
  function invoke_12(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits, timeZone) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    return {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits, timeZone: timeZone};
  }
  function copy_12(_this__u8e3s4, era, eraYear, year, month, monthCode) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return Object.assign({}, _this__u8e3s4, {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode});
  }
  function invoke_13(_this__u8e3s4, era, eraYear, year, month, monthCode) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return {era: era, eraYear: eraYear, year: year, month: month, monthCode: monthCode};
  }
  function copy_13(_this__u8e3s4, month, monthCode) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return Object.assign({}, _this__u8e3s4, {month: month, monthCode: monthCode});
  }
  function invoke_14(_this__u8e3s4, month, monthCode) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    return {month: month, monthCode: monthCode};
  }
  function copy_14(_this__u8e3s4, offset) {
    offset = offset === VOID ? VOID : offset;
    return Object.assign({}, _this__u8e3s4, {offset: offset});
  }
  function invoke_15(_this__u8e3s4, offset) {
    offset = offset === VOID ? VOID : offset;
    return {offset: offset};
  }
  function copy_15(_this__u8e3s4, isoDay, calendar, isoMonth, isoYear) {
    isoDay = isoDay === VOID ? VOID : isoDay;
    calendar = calendar === VOID ? VOID : calendar;
    isoMonth = isoMonth === VOID ? VOID : isoMonth;
    isoYear = isoYear === VOID ? VOID : isoYear;
    return Object.assign({}, _this__u8e3s4, {isoDay: isoDay, calendar: calendar, isoMonth: isoMonth, isoYear: isoYear});
  }
  function invoke_16(_this__u8e3s4, isoDay, calendar, isoMonth, isoYear) {
    return {isoDay: isoDay, calendar: calendar, isoMonth: isoMonth, isoYear: isoYear};
  }
  function copy_16(_this__u8e3s4, month, monthCode, calendar, era, eraYear, day, year) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    day = day === VOID ? VOID : day;
    year = year === VOID ? VOID : year;
    return Object.assign({}, _this__u8e3s4, {month: month, monthCode: monthCode, calendar: calendar, era: era, eraYear: eraYear, day: day, year: year});
  }
  function invoke_17(_this__u8e3s4, month, monthCode, calendar, era, eraYear, day, year) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    day = day === VOID ? VOID : day;
    year = year === VOID ? VOID : year;
    return {month: month, monthCode: monthCode, calendar: calendar, era: era, eraYear: eraYear, day: day, year: year};
  }
  function copy_17(_this__u8e3s4, isoDay, isoSecond, calendar, isoMonth, isoMinute, isoMicrosecond, isoNanosecond, isoYear, isoHour, isoMillisecond) {
    isoDay = isoDay === VOID ? VOID : isoDay;
    isoSecond = isoSecond === VOID ? VOID : isoSecond;
    calendar = calendar === VOID ? VOID : calendar;
    isoMonth = isoMonth === VOID ? VOID : isoMonth;
    isoMinute = isoMinute === VOID ? VOID : isoMinute;
    isoMicrosecond = isoMicrosecond === VOID ? VOID : isoMicrosecond;
    isoNanosecond = isoNanosecond === VOID ? VOID : isoNanosecond;
    isoYear = isoYear === VOID ? VOID : isoYear;
    isoHour = isoHour === VOID ? VOID : isoHour;
    isoMillisecond = isoMillisecond === VOID ? VOID : isoMillisecond;
    return Object.assign({}, _this__u8e3s4, {isoDay: isoDay, isoSecond: isoSecond, calendar: calendar, isoMonth: isoMonth, isoMinute: isoMinute, isoMicrosecond: isoMicrosecond, isoNanosecond: isoNanosecond, isoYear: isoYear, isoHour: isoHour, isoMillisecond: isoMillisecond});
  }
  function invoke_18(_this__u8e3s4, isoDay, isoSecond, calendar, isoMonth, isoMinute, isoMicrosecond, isoNanosecond, isoYear, isoHour, isoMillisecond) {
    return {isoDay: isoDay, isoSecond: isoSecond, calendar: calendar, isoMonth: isoMonth, isoMinute: isoMinute, isoMicrosecond: isoMicrosecond, isoNanosecond: isoNanosecond, isoYear: isoYear, isoHour: isoHour, isoMillisecond: isoMillisecond};
  }
  function copy_18(_this__u8e3s4, second, calendar, era, microsecond, nanosecond, day, millisecond, month, hour, monthCode, minute, eraYear, year) {
    second = second === VOID ? VOID : second;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    microsecond = microsecond === VOID ? VOID : microsecond;
    nanosecond = nanosecond === VOID ? VOID : nanosecond;
    day = day === VOID ? VOID : day;
    millisecond = millisecond === VOID ? VOID : millisecond;
    month = month === VOID ? VOID : month;
    hour = hour === VOID ? VOID : hour;
    monthCode = monthCode === VOID ? VOID : monthCode;
    minute = minute === VOID ? VOID : minute;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    return Object.assign({}, _this__u8e3s4, {second: second, calendar: calendar, era: era, microsecond: microsecond, nanosecond: nanosecond, day: day, millisecond: millisecond, month: month, hour: hour, monthCode: monthCode, minute: minute, eraYear: eraYear, year: year});
  }
  function invoke_19(_this__u8e3s4, second, calendar, era, microsecond, nanosecond, day, millisecond, month, hour, monthCode, minute, eraYear, year) {
    second = second === VOID ? VOID : second;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    microsecond = microsecond === VOID ? VOID : microsecond;
    nanosecond = nanosecond === VOID ? VOID : nanosecond;
    day = day === VOID ? VOID : day;
    millisecond = millisecond === VOID ? VOID : millisecond;
    month = month === VOID ? VOID : month;
    hour = hour === VOID ? VOID : hour;
    monthCode = monthCode === VOID ? VOID : monthCode;
    minute = minute === VOID ? VOID : minute;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    return {second: second, calendar: calendar, era: era, microsecond: microsecond, nanosecond: nanosecond, day: day, millisecond: millisecond, month: month, hour: hour, monthCode: monthCode, minute: minute, eraYear: eraYear, year: year};
  }
  function copy_19(_this__u8e3s4, month, monthCode, calendar, era, eraYear, day, year) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    day = day === VOID ? VOID : day;
    year = year === VOID ? VOID : year;
    return Object.assign({}, _this__u8e3s4, {month: month, monthCode: monthCode, calendar: calendar, era: era, eraYear: eraYear, day: day, year: year});
  }
  function invoke_20(_this__u8e3s4, month, monthCode, calendar, era, eraYear, day, year) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    day = day === VOID ? VOID : day;
    year = year === VOID ? VOID : year;
    return {month: month, monthCode: monthCode, calendar: calendar, era: era, eraYear: eraYear, day: day, year: year};
  }
  function copy_20(_this__u8e3s4, isoSecond, isoMinute, isoMicrosecond, isoNanosecond, isoHour, isoMillisecond) {
    isoSecond = isoSecond === VOID ? VOID : isoSecond;
    isoMinute = isoMinute === VOID ? VOID : isoMinute;
    isoMicrosecond = isoMicrosecond === VOID ? VOID : isoMicrosecond;
    isoNanosecond = isoNanosecond === VOID ? VOID : isoNanosecond;
    isoHour = isoHour === VOID ? VOID : isoHour;
    isoMillisecond = isoMillisecond === VOID ? VOID : isoMillisecond;
    return Object.assign({}, _this__u8e3s4, {isoSecond: isoSecond, isoMinute: isoMinute, isoMicrosecond: isoMicrosecond, isoNanosecond: isoNanosecond, isoHour: isoHour, isoMillisecond: isoMillisecond});
  }
  function invoke_21(_this__u8e3s4, isoSecond, isoMinute, isoMicrosecond, isoNanosecond, isoHour, isoMillisecond) {
    return {isoSecond: isoSecond, isoMinute: isoMinute, isoMicrosecond: isoMicrosecond, isoNanosecond: isoNanosecond, isoHour: isoHour, isoMillisecond: isoMillisecond};
  }
  function copy_21(_this__u8e3s4, hour, second, minute, microsecond, nanosecond, millisecond) {
    hour = hour === VOID ? VOID : hour;
    second = second === VOID ? VOID : second;
    minute = minute === VOID ? VOID : minute;
    microsecond = microsecond === VOID ? VOID : microsecond;
    nanosecond = nanosecond === VOID ? VOID : nanosecond;
    millisecond = millisecond === VOID ? VOID : millisecond;
    return Object.assign({}, _this__u8e3s4, {hour: hour, second: second, minute: minute, microsecond: microsecond, nanosecond: nanosecond, millisecond: millisecond});
  }
  function invoke_22(_this__u8e3s4, hour, second, minute, microsecond, nanosecond, millisecond) {
    hour = hour === VOID ? VOID : hour;
    second = second === VOID ? VOID : second;
    minute = minute === VOID ? VOID : minute;
    microsecond = microsecond === VOID ? VOID : microsecond;
    nanosecond = nanosecond === VOID ? VOID : nanosecond;
    millisecond = millisecond === VOID ? VOID : millisecond;
    return {hour: hour, second: second, minute: minute, microsecond: microsecond, nanosecond: nanosecond, millisecond: millisecond};
  }
  function copy_22(_this__u8e3s4, month, monthCode, calendar, era, eraYear, year) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    return Object.assign({}, _this__u8e3s4, {month: month, monthCode: monthCode, calendar: calendar, era: era, eraYear: eraYear, year: year});
  }
  function invoke_23(_this__u8e3s4, month, monthCode, calendar, era, eraYear, year) {
    month = month === VOID ? VOID : month;
    monthCode = monthCode === VOID ? VOID : monthCode;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    return {month: month, monthCode: monthCode, calendar: calendar, era: era, eraYear: eraYear, year: year};
  }
  function copy_23(_this__u8e3s4, roundingIncrement, smallestUnit, roundingMode) {
    roundingIncrement = roundingIncrement === VOID ? VOID : roundingIncrement;
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    return Object.assign({}, _this__u8e3s4, {roundingIncrement: roundingIncrement, smallestUnit: smallestUnit, roundingMode: roundingMode});
  }
  function invoke_24(_this__u8e3s4, roundingIncrement, smallestUnit, roundingMode) {
    roundingIncrement = roundingIncrement === VOID ? VOID : roundingIncrement;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    return {roundingIncrement: roundingIncrement, smallestUnit: smallestUnit, roundingMode: roundingMode};
  }
  function copy_24(_this__u8e3s4, calendarName) {
    calendarName = calendarName === VOID ? VOID : calendarName;
    return Object.assign({}, _this__u8e3s4, {calendarName: calendarName});
  }
  function invoke_25(_this__u8e3s4, calendarName) {
    calendarName = calendarName === VOID ? VOID : calendarName;
    return {calendarName: calendarName};
  }
  function copy_25(_this__u8e3s4, getPlainDateTimeFor, id, toString, getOffsetNanosecondsFor, getPreviousTransition, getPossibleInstantsFor, toJSON, getOffsetStringFor, getInstantFor, getNextTransition) {
    getPlainDateTimeFor = getPlainDateTimeFor === VOID ? VOID : getPlainDateTimeFor;
    id = id === VOID ? VOID : id;
    toString = toString === VOID ? VOID : toString;
    getOffsetNanosecondsFor = getOffsetNanosecondsFor === VOID ? VOID : getOffsetNanosecondsFor;
    getPreviousTransition = getPreviousTransition === VOID ? VOID : getPreviousTransition;
    getPossibleInstantsFor = getPossibleInstantsFor === VOID ? VOID : getPossibleInstantsFor;
    toJSON = toJSON === VOID ? VOID : toJSON;
    getOffsetStringFor = getOffsetStringFor === VOID ? VOID : getOffsetStringFor;
    getInstantFor = getInstantFor === VOID ? VOID : getInstantFor;
    getNextTransition = getNextTransition === VOID ? VOID : getNextTransition;
    return Object.assign({}, _this__u8e3s4, {getPlainDateTimeFor: getPlainDateTimeFor, id: id, toString: toString, getOffsetNanosecondsFor: getOffsetNanosecondsFor, getPreviousTransition: getPreviousTransition, getPossibleInstantsFor: getPossibleInstantsFor, toJSON: toJSON, getOffsetStringFor: getOffsetStringFor, getInstantFor: getInstantFor, getNextTransition: getNextTransition});
  }
  function invoke_26(_this__u8e3s4, getPlainDateTimeFor, id, toString, getOffsetNanosecondsFor, getPreviousTransition, getPossibleInstantsFor, toJSON, getOffsetStringFor, getInstantFor, getNextTransition) {
    getPlainDateTimeFor = getPlainDateTimeFor === VOID ? VOID : getPlainDateTimeFor;
    toString = toString === VOID ? VOID : toString;
    getPreviousTransition = getPreviousTransition === VOID ? VOID : getPreviousTransition;
    toJSON = toJSON === VOID ? VOID : toJSON;
    getOffsetStringFor = getOffsetStringFor === VOID ? VOID : getOffsetStringFor;
    getInstantFor = getInstantFor === VOID ? VOID : getInstantFor;
    getNextTransition = getNextTransition === VOID ? VOID : getNextTransition;
    return {getPlainDateTimeFor: getPlainDateTimeFor, id: id, toString: toString, getOffsetNanosecondsFor: getOffsetNanosecondsFor, getPreviousTransition: getPreviousTransition, getPossibleInstantsFor: getPossibleInstantsFor, toJSON: toJSON, getOffsetStringFor: getOffsetStringFor, getInstantFor: getInstantFor, getNextTransition: getNextTransition};
  }
  function copy_26(_this__u8e3s4, disambiguation) {
    disambiguation = disambiguation === VOID ? VOID : disambiguation;
    return Object.assign({}, _this__u8e3s4, {disambiguation: disambiguation});
  }
  function invoke_27(_this__u8e3s4, disambiguation) {
    disambiguation = disambiguation === VOID ? VOID : disambiguation;
    return {disambiguation: disambiguation};
  }
  function copy_27(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    return Object.assign({}, _this__u8e3s4, {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits});
  }
  function invoke_28(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    return {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits};
  }
  function copy_28(_this__u8e3s4, era, eraYear, year) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    return Object.assign({}, _this__u8e3s4, {era: era, eraYear: eraYear, year: year});
  }
  function invoke_29(_this__u8e3s4, era, eraYear, year) {
    era = era === VOID ? VOID : era;
    eraYear = eraYear === VOID ? VOID : eraYear;
    year = year === VOID ? VOID : year;
    return {era: era, eraYear: eraYear, year: year};
  }
  function copy_29(_this__u8e3s4, overflow, disambiguation, offset) {
    overflow = overflow === VOID ? VOID : overflow;
    disambiguation = disambiguation === VOID ? VOID : disambiguation;
    offset = offset === VOID ? VOID : offset;
    return Object.assign({}, _this__u8e3s4, {overflow: overflow, disambiguation: disambiguation, offset: offset});
  }
  function invoke_30(_this__u8e3s4, overflow, disambiguation, offset) {
    overflow = overflow === VOID ? VOID : overflow;
    disambiguation = disambiguation === VOID ? VOID : disambiguation;
    offset = offset === VOID ? VOID : offset;
    return {overflow: overflow, disambiguation: disambiguation, offset: offset};
  }
  function copy_30(_this__u8e3s4, isoDay, timeZone, isoSecond, calendar, isoMonth, isoNanosecond, isoHour, isoMillisecond, isoMinute, isoMicrosecond, offset, isoYear) {
    isoDay = isoDay === VOID ? VOID : isoDay;
    timeZone = timeZone === VOID ? VOID : timeZone;
    isoSecond = isoSecond === VOID ? VOID : isoSecond;
    calendar = calendar === VOID ? VOID : calendar;
    isoMonth = isoMonth === VOID ? VOID : isoMonth;
    isoNanosecond = isoNanosecond === VOID ? VOID : isoNanosecond;
    isoHour = isoHour === VOID ? VOID : isoHour;
    isoMillisecond = isoMillisecond === VOID ? VOID : isoMillisecond;
    isoMinute = isoMinute === VOID ? VOID : isoMinute;
    isoMicrosecond = isoMicrosecond === VOID ? VOID : isoMicrosecond;
    offset = offset === VOID ? VOID : offset;
    isoYear = isoYear === VOID ? VOID : isoYear;
    return Object.assign({}, _this__u8e3s4, {isoDay: isoDay, timeZone: timeZone, isoSecond: isoSecond, calendar: calendar, isoMonth: isoMonth, isoNanosecond: isoNanosecond, isoHour: isoHour, isoMillisecond: isoMillisecond, isoMinute: isoMinute, isoMicrosecond: isoMicrosecond, offset: offset, isoYear: isoYear});
  }
  function invoke_31(_this__u8e3s4, isoDay, timeZone, isoSecond, calendar, isoMonth, isoNanosecond, isoHour, isoMillisecond, isoMinute, isoMicrosecond, offset, isoYear) {
    return {isoDay: isoDay, timeZone: timeZone, isoSecond: isoSecond, calendar: calendar, isoMonth: isoMonth, isoNanosecond: isoNanosecond, isoHour: isoHour, isoMillisecond: isoMillisecond, isoMinute: isoMinute, isoMicrosecond: isoMicrosecond, offset: offset, isoYear: isoYear};
  }
  function copy_31(_this__u8e3s4, second, timeZone, calendar, era, microsecond, nanosecond, day, millisecond, month, hour, monthCode, minute, eraYear, offset, year) {
    second = second === VOID ? VOID : second;
    timeZone = timeZone === VOID ? VOID : timeZone;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    microsecond = microsecond === VOID ? VOID : microsecond;
    nanosecond = nanosecond === VOID ? VOID : nanosecond;
    day = day === VOID ? VOID : day;
    millisecond = millisecond === VOID ? VOID : millisecond;
    month = month === VOID ? VOID : month;
    hour = hour === VOID ? VOID : hour;
    monthCode = monthCode === VOID ? VOID : monthCode;
    minute = minute === VOID ? VOID : minute;
    eraYear = eraYear === VOID ? VOID : eraYear;
    offset = offset === VOID ? VOID : offset;
    year = year === VOID ? VOID : year;
    return Object.assign({}, _this__u8e3s4, {second: second, timeZone: timeZone, calendar: calendar, era: era, microsecond: microsecond, nanosecond: nanosecond, day: day, millisecond: millisecond, month: month, hour: hour, monthCode: monthCode, minute: minute, eraYear: eraYear, offset: offset, year: year});
  }
  function invoke_32(_this__u8e3s4, second, timeZone, calendar, era, microsecond, nanosecond, day, millisecond, month, hour, monthCode, minute, eraYear, offset, year) {
    second = second === VOID ? VOID : second;
    timeZone = timeZone === VOID ? VOID : timeZone;
    calendar = calendar === VOID ? VOID : calendar;
    era = era === VOID ? VOID : era;
    microsecond = microsecond === VOID ? VOID : microsecond;
    nanosecond = nanosecond === VOID ? VOID : nanosecond;
    day = day === VOID ? VOID : day;
    millisecond = millisecond === VOID ? VOID : millisecond;
    month = month === VOID ? VOID : month;
    hour = hour === VOID ? VOID : hour;
    monthCode = monthCode === VOID ? VOID : monthCode;
    minute = minute === VOID ? VOID : minute;
    eraYear = eraYear === VOID ? VOID : eraYear;
    offset = offset === VOID ? VOID : offset;
    year = year === VOID ? VOID : year;
    return {second: second, timeZone: timeZone, calendar: calendar, era: era, microsecond: microsecond, nanosecond: nanosecond, day: day, millisecond: millisecond, month: month, hour: hour, monthCode: monthCode, minute: minute, eraYear: eraYear, offset: offset, year: year};
  }
  function copy_32(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits, calendarName, offset, timeZoneName) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    calendarName = calendarName === VOID ? VOID : calendarName;
    offset = offset === VOID ? VOID : offset;
    timeZoneName = timeZoneName === VOID ? VOID : timeZoneName;
    return Object.assign({}, _this__u8e3s4, {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits, calendarName: calendarName, offset: offset, timeZoneName: timeZoneName});
  }
  function invoke_33(_this__u8e3s4, smallestUnit, roundingMode, fractionalSecondDigits, calendarName, offset, timeZoneName) {
    smallestUnit = smallestUnit === VOID ? VOID : smallestUnit;
    roundingMode = roundingMode === VOID ? VOID : roundingMode;
    fractionalSecondDigits = fractionalSecondDigits === VOID ? VOID : fractionalSecondDigits;
    calendarName = calendarName === VOID ? VOID : calendarName;
    offset = offset === VOID ? VOID : offset;
    timeZoneName = timeZoneName === VOID ? VOID : timeZoneName;
    return {smallestUnit: smallestUnit, roundingMode: roundingMode, fractionalSecondDigits: fractionalSecondDigits, calendarName: calendarName, offset: offset, timeZoneName: timeZoneName};
  }
  function copy_33(_this__u8e3s4, lastChunkHandling, alphabet) {
    lastChunkHandling = lastChunkHandling === VOID ? VOID : lastChunkHandling;
    alphabet = alphabet === VOID ? VOID : alphabet;
    return Object.assign({}, _this__u8e3s4, {lastChunkHandling: lastChunkHandling, alphabet: alphabet});
  }
  function invoke_34(_this__u8e3s4, lastChunkHandling, alphabet) {
    lastChunkHandling = lastChunkHandling === VOID ? VOID : lastChunkHandling;
    alphabet = alphabet === VOID ? VOID : alphabet;
    return {lastChunkHandling: lastChunkHandling, alphabet: alphabet};
  }
  function copy_34(_this__u8e3s4, written, read) {
    written = written === VOID ? VOID : written;
    read = read === VOID ? VOID : read;
    return Object.assign({}, _this__u8e3s4, {written: written, read: read});
  }
  function invoke_35(_this__u8e3s4, written, read) {
    return {written: written, read: read};
  }
  function copy_35(_this__u8e3s4, omitPadding, alphabet) {
    omitPadding = omitPadding === VOID ? VOID : omitPadding;
    alphabet = alphabet === VOID ? VOID : alphabet;
    return Object.assign({}, _this__u8e3s4, {omitPadding: omitPadding, alphabet: alphabet});
  }
  function invoke_36(_this__u8e3s4, omitPadding, alphabet) {
    omitPadding = omitPadding === VOID ? VOID : omitPadding;
    alphabet = alphabet === VOID ? VOID : alphabet;
    return {omitPadding: omitPadding, alphabet: alphabet};
  }
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./kotlinx-coroutines-core.js')));

//# sourceMappingURL=kotlin-js.js.map
