(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var initMetadataForObject = kotlin_kotlin.$_$.f4;
  var VOID = kotlin_kotlin.$_$.d;
  var initMetadataForClass = kotlin_kotlin.$_$.c4;
  var toString = kotlin_kotlin.$_$.v7;
  //endregion
  //region block: pre-declaration
  class atomicfu$TraceBase {
    atomicfu$Trace$append$1(event) {
    }
    atomicfu$Trace$append$2(event1, event2) {
    }
    atomicfu$Trace$append$3(event1, event2, event3) {
    }
    atomicfu$Trace$append$4(event1, event2, event3, event4) {
    }
  }
  class None extends atomicfu$TraceBase {
    constructor() {
      None_instance = null;
      super();
      None_instance = this;
    }
  }
  class AtomicRef {
    constructor(value) {
      this.kotlinx$atomicfu$value = value;
    }
    b19(_set____db54di) {
      this.kotlinx$atomicfu$value = _set____db54di;
    }
    c19() {
      return this.kotlinx$atomicfu$value;
    }
    atomicfu$compareAndSet(expect, update) {
      if (!(this.kotlinx$atomicfu$value === expect))
        return false;
      this.kotlinx$atomicfu$value = update;
      return true;
    }
    atomicfu$getAndSet(value) {
      var oldValue = this.kotlinx$atomicfu$value;
      this.kotlinx$atomicfu$value = value;
      return oldValue;
    }
    toString() {
      return toString(this.kotlinx$atomicfu$value);
    }
  }
  class AtomicBoolean {
    constructor(value) {
      this.kotlinx$atomicfu$value = value;
    }
    d19(_set____db54di) {
      this.kotlinx$atomicfu$value = _set____db54di;
    }
    c19() {
      return this.kotlinx$atomicfu$value;
    }
    atomicfu$compareAndSet(expect, update) {
      if (!(this.kotlinx$atomicfu$value === expect))
        return false;
      this.kotlinx$atomicfu$value = update;
      return true;
    }
    atomicfu$getAndSet(value) {
      var oldValue = this.kotlinx$atomicfu$value;
      this.kotlinx$atomicfu$value = value;
      return oldValue;
    }
    toString() {
      return this.kotlinx$atomicfu$value.toString();
    }
  }
  class AtomicInt {
    constructor(value) {
      this.kotlinx$atomicfu$value = value;
    }
    e19(_set____db54di) {
      this.kotlinx$atomicfu$value = _set____db54di;
    }
    c19() {
      return this.kotlinx$atomicfu$value;
    }
    atomicfu$compareAndSet(expect, update) {
      if (!(this.kotlinx$atomicfu$value === expect))
        return false;
      this.kotlinx$atomicfu$value = update;
      return true;
    }
    atomicfu$getAndSet(value) {
      var oldValue = this.kotlinx$atomicfu$value;
      this.kotlinx$atomicfu$value = value;
      return oldValue;
    }
    atomicfu$getAndIncrement() {
      var _unary__edvuaz = this.kotlinx$atomicfu$value;
      this.kotlinx$atomicfu$value = _unary__edvuaz + 1 | 0;
      return _unary__edvuaz;
    }
    atomicfu$getAndDecrement() {
      var _unary__edvuaz = this.kotlinx$atomicfu$value;
      this.kotlinx$atomicfu$value = _unary__edvuaz - 1 | 0;
      return _unary__edvuaz;
    }
    atomicfu$getAndAdd(delta) {
      var oldValue = this.kotlinx$atomicfu$value;
      this.kotlinx$atomicfu$value = this.kotlinx$atomicfu$value + delta | 0;
      return oldValue;
    }
    atomicfu$addAndGet(delta) {
      this.kotlinx$atomicfu$value = this.kotlinx$atomicfu$value + delta | 0;
      return this.kotlinx$atomicfu$value;
    }
    atomicfu$incrementAndGet() {
      this.kotlinx$atomicfu$value = this.kotlinx$atomicfu$value + 1 | 0;
      return this.kotlinx$atomicfu$value;
    }
    atomicfu$decrementAndGet() {
      this.kotlinx$atomicfu$value = this.kotlinx$atomicfu$value - 1 | 0;
      return this.kotlinx$atomicfu$value;
    }
    toString() {
      return this.kotlinx$atomicfu$value.toString();
    }
  }
  //endregion
  var None_instance;
  function None_getInstance() {
    if (None_instance === VOID)
      new None();
    return None_instance;
  }
  function atomic$ref$1(initial) {
    return atomic$ref$(initial, None_getInstance());
  }
  function atomic$boolean$1(initial) {
    return atomic$boolean$(initial, None_getInstance());
  }
  function atomic$int$1(initial) {
    return atomic$int$(initial, None_getInstance());
  }
  function atomic$ref$(initial, trace) {
    trace = trace === VOID ? None_getInstance() : trace;
    return new AtomicRef(initial);
  }
  function atomic$boolean$(initial, trace) {
    trace = trace === VOID ? None_getInstance() : trace;
    return new AtomicBoolean(initial);
  }
  function atomic$int$(initial, trace) {
    trace = trace === VOID ? None_getInstance() : trace;
    return new AtomicInt(initial);
  }
  //region block: post-declaration
  initMetadataForClass(atomicfu$TraceBase, 'TraceBase');
  initMetadataForObject(None, 'None');
  initMetadataForClass(AtomicRef, 'AtomicRef');
  initMetadataForClass(AtomicBoolean, 'AtomicBoolean');
  initMetadataForClass(AtomicInt, 'AtomicInt');
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = atomic$boolean$1;
  _.$_$.b = atomic$ref$1;
  _.$_$.c = atomic$int$1;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=kotlinx-atomicfu.js.map
