(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_atomicfu) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var UnsupportedOperationException = kotlin_kotlin.$_$.e7;
  var Unit_instance = kotlin_kotlin.$_$.v;
  var isInterface = kotlin_kotlin.$_$.i4;
  var THROW_CCE = kotlin_kotlin.$_$.c7;
  var IllegalStateException = kotlin_kotlin.$_$.t6;
  var toString = kotlin_kotlin.$_$.w4;
  var VOID = kotlin_kotlin.$_$.d;
  var toString_0 = kotlin_kotlin.$_$.v7;
  var atomic$int$1 = kotlin_org_jetbrains_kotlinx_atomicfu.$_$.c;
  var atomic$ref$1 = kotlin_org_jetbrains_kotlinx_atomicfu.$_$.b;
  var get_COROUTINE_SUSPENDED = kotlin_kotlin.$_$.x2;
  var initMetadataForClass = kotlin_kotlin.$_$.c4;
  var initMetadataForInterface = kotlin_kotlin.$_$.e4;
  var initMetadataForObject = kotlin_kotlin.$_$.f4;
  var hashCode = kotlin_kotlin.$_$.b4;
  var equals = kotlin_kotlin.$_$.x3;
  var atomic$boolean$1 = kotlin_org_jetbrains_kotlinx_atomicfu.$_$.a;
  var CancellationException = kotlin_kotlin.$_$.w2;
  var Result__exceptionOrNull_impl_p6xea9 = kotlin_kotlin.$_$.j;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.k;
  var AbstractCoroutineContextKey = kotlin_kotlin.$_$.a3;
  var Key_instance = kotlin_kotlin.$_$.q;
  var AbstractCoroutineContextElement = kotlin_kotlin.$_$.z2;
  var get = kotlin_kotlin.$_$.b3;
  var protoOf = kotlin_kotlin.$_$.s4;
  var ContinuationInterceptor = kotlin_kotlin.$_$.c3;
  var RuntimeException = kotlin_kotlin.$_$.b7;
  var addSuppressed = kotlin_kotlin.$_$.f7;
  var Long = kotlin_kotlin.$_$.v6;
  var ArrayDeque = kotlin_kotlin.$_$.x;
  var captureStack = kotlin_kotlin.$_$.p3;
  var Error_0 = kotlin_kotlin.$_$.q6;
  var StringBuilder = kotlin_kotlin.$_$.w5;
  var throwUninitializedPropertyAccessException = kotlin_kotlin.$_$.s7;
  var Element = kotlin_kotlin.$_$.d3;
  var anyToString = kotlin_kotlin.$_$.l3;
  var Exception = kotlin_kotlin.$_$.r6;
  var IllegalArgumentException = kotlin_kotlin.$_$.s6;
  var Companion_instance = kotlin_kotlin.$_$.u;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.i;
  var createFailure = kotlin_kotlin.$_$.g7;
  var getKClassFromExpression = kotlin_kotlin.$_$.a;
  var LinkedHashSet = kotlin_kotlin.$_$.c1;
  //endregion
  //region block: pre-declaration
  class SchedulerTask {}
  class DispatchedTask extends SchedulerTask {
    constructor(resumeMode) {
      super();
      this.u19_1 = resumeMode;
    }
    s1a(takenState, cause) {
    }
    c1b(state) {
      return (state == null ? true : !(state == null)) ? state : THROW_CCE();
    }
    l1b(state) {
      var tmp0_safe_receiver = state instanceof CompletedExceptionally ? state : null;
      return tmp0_safe_receiver == null ? null : tmp0_safe_receiver.j1a_1;
    }
    y17() {
      // Inline function 'kotlinx.coroutines.assert' call
      try {
        var tmp = this.n1a();
        var delegate = tmp instanceof DispatchedContinuation ? tmp : THROW_CCE();
        var continuation = delegate.p19_1;
        // Inline function 'kotlinx.coroutines.withContinuationContext' call
        delegate.r19_1;
        // Inline function 'kotlinx.coroutines.DispatchedTask.run.<anonymous>' call
        var context = continuation.dc();
        var state = this.r1a();
        var exception = this.l1b(state);
        var job = exception == null && get_isCancellableMode(this.u19_1) ? context.ec(Key_instance_2) : null;
        if (!(job == null) && !job.b13()) {
          var cause = job.z1a();
          this.s1a(state, cause);
          // Inline function 'kotlinx.coroutines.resumeWithStackTrace' call
          // Inline function 'kotlin.Companion.failure' call
          var exception_0 = recoverStackTrace(cause, continuation);
          var tmp$ret$0 = _Result___init__impl__xyqfz8(createFailure(exception_0));
          continuation.fh(tmp$ret$0);
        } else {
          if (!(exception == null)) {
            // Inline function 'kotlin.coroutines.resumeWithException' call
            // Inline function 'kotlin.Companion.failure' call
            var tmp$ret$1 = _Result___init__impl__xyqfz8(createFailure(exception));
            continuation.fh(tmp$ret$1);
          } else {
            // Inline function 'kotlin.coroutines.resume' call
            // Inline function 'kotlin.Companion.success' call
            var value = this.c1b(state);
            var tmp$ret$3 = _Result___init__impl__xyqfz8(value);
            continuation.fh(tmp$ret$3);
          }
        }
      } catch ($p) {
        if ($p instanceof DispatchException) {
          var e = $p;
          handleCoroutineException(this.n1a().dc(), e.m1c_1);
        } else {
          if ($p instanceof Error) {
            var e_0 = $p;
            this.n1b(e_0);
          } else {
            throw $p;
          }
        }
      }
    }
    n1b(exception) {
      var reason = CoroutinesInternalError.g1d('Fatal exception in coroutines machinery for ' + toString(this) + '. ' + "Please read KDoc to 'handleFatalException' method and report this incident to maintainers", exception);
      handleCoroutineException(this.n1a().dc(), reason);
    }
  }
  class CancellableContinuationImpl extends DispatchedTask {
    constructor(delegate, resumeMode) {
      super(resumeMode);
      this.g19_1 = delegate;
      // Inline function 'kotlinx.coroutines.assert' call
      this.h19_1 = this.g19_1.dc();
      var tmp = this;
      // Inline function 'kotlinx.coroutines.decisionAndIndex' call
      var tmp$ret$0 = (0 << 29) + 536870911 | 0;
      tmp.i19_1 = atomic$int$1(tmp$ret$0);
      this.j19_1 = atomic$ref$1(Active_instance);
      this.k19_1 = atomic$ref$1(null);
    }
    n1a() {
      return this.g19_1;
    }
    dc() {
      return this.h19_1;
    }
    m19() {
      return this.j19_1.kotlinx$atomicfu$value;
    }
    o1a() {
      var tmp = this.m19();
      return !(!(tmp == null) ? isInterface(tmp, NotCompleted) : false);
    }
    p1a() {
      var tmp0_elvis_lhs = installParentHandle(this);
      var tmp;
      if (tmp0_elvis_lhs == null) {
        return Unit_instance;
      } else {
        tmp = tmp0_elvis_lhs;
      }
      var handle = tmp;
      if (this.o1a()) {
        handle.q1a();
        this.k19_1.kotlinx$atomicfu$value = NonDisposableHandle_instance;
      }
    }
    r1a() {
      return this.m19();
    }
    s1a(takenState, cause) {
      var this_0 = this.j19_1;
      while (true) {
        // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.cancelCompletedResult.<anonymous>' call
        var state = this_0.kotlinx$atomicfu$value;
        if (!(state == null) ? isInterface(state, NotCompleted) : false) {
          // Inline function 'kotlin.error' call
          var message = 'Not completed';
          throw IllegalStateException.n4(toString(message));
        } else {
          if (state instanceof CompletedExceptionally)
            return Unit_instance;
          else {
            if (state instanceof CompletedContinuation) {
              // Inline function 'kotlin.check' call
              if (!!state.h1a()) {
                // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.cancelCompletedResult.<anonymous>.<anonymous>' call
                var message_0 = 'Must be called at most once';
                throw IllegalStateException.n4(toString(message_0));
              }
              var update = state.i1a(VOID, VOID, VOID, VOID, cause);
              if (this.j19_1.atomicfu$compareAndSet(state, update)) {
                state.t1a(this, cause);
                return Unit_instance;
              }
            } else {
              if (this.j19_1.atomicfu$compareAndSet(state, new CompletedContinuation(state, VOID, VOID, VOID, cause))) {
                return Unit_instance;
              }
            }
          }
        }
      }
      return Unit_instance;
    }
    u1a(cause) {
      // Inline function 'kotlinx.atomicfu.loop' call
      var this_0 = this.j19_1;
      while (true) {
        var tmp1 = this_0.kotlinx$atomicfu$value;
        $l$block: {
          // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.cancel.<anonymous>' call
          if (!(!(tmp1 == null) ? isInterface(tmp1, NotCompleted) : false))
            return false;
          var tmp;
          if (isInterface(tmp1, CancelHandler)) {
            tmp = true;
          } else {
            tmp = tmp1 instanceof Segment;
          }
          var update = new CancelledContinuation(this, cause, tmp);
          if (!this.j19_1.atomicfu$compareAndSet(tmp1, update)) {
            break $l$block;
          }
          if (isInterface(tmp1, CancelHandler)) {
            this.g1a(tmp1, cause);
          } else {
            if (tmp1 instanceof Segment) {
              callSegmentOnCancellation(this, tmp1, cause);
            }
          }
          detachChildIfNonReusable(this);
          dispatchResume(this, this.u19_1);
          return true;
        }
      }
    }
    v1a(cause) {
      if (cancelLater(this, cause))
        return Unit_instance;
      this.u1a(cause);
      detachChildIfNonReusable(this);
    }
    g1a(handler, cause) {
      var tmp;
      try {
        handler.w1a(cause);
        tmp = Unit_instance;
      } catch ($p) {
        var tmp_0;
        if ($p instanceof Error) {
          var ex = $p;
          handleCoroutineException(this.dc(), CompletionHandlerException.a1a('Exception in invokeOnCancellation handler for ' + this.toString(), ex));
          tmp_0 = Unit_instance;
        } else {
          throw $p;
        }
        tmp = tmp_0;
      }
      return tmp;
    }
    x1a(onCancellation, cause, value) {
      try {
        onCancellation(cause, value, this.dc());
      } catch ($p) {
        if ($p instanceof Error) {
          var ex = $p;
          handleCoroutineException(this.dc(), CompletionHandlerException.a1a('Exception in resume onCancellation handler for ' + this.toString(), ex));
        } else {
          throw $p;
        }
      }
    }
    y1a(parent) {
      return parent.z1a();
    }
    a1b() {
      var isReusable_0 = isReusable(this);
      if (trySuspend(this)) {
        if (_get_parentHandle__f8dcex(this) == null) {
          installParentHandle(this);
        }
        if (isReusable_0) {
          this.b1b();
        }
        return get_COROUTINE_SUSPENDED();
      }
      if (isReusable_0) {
        this.b1b();
      }
      var state = this.m19();
      if (state instanceof CompletedExceptionally)
        throw recoverStackTrace(state.j1a_1, this);
      if (get_isCancellableMode(this.u19_1)) {
        var job = this.dc().ec(Key_instance_2);
        if (!(job == null) && !job.b13()) {
          var cause = job.z1a();
          this.s1a(state, cause);
          throw recoverStackTrace(cause, this);
        }
      }
      return this.c1b(state);
    }
    b1b() {
      var tmp = this.g19_1;
      var tmp0_safe_receiver = tmp instanceof DispatchedContinuation ? tmp : null;
      var tmp1_elvis_lhs = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.d1b(this);
      var tmp_0;
      if (tmp1_elvis_lhs == null) {
        return Unit_instance;
      } else {
        tmp_0 = tmp1_elvis_lhs;
      }
      var cancellationCause = tmp_0;
      this.m1a();
      this.u1a(cancellationCause);
    }
    fh(result) {
      return this.e1b(toState(result, this), this.u19_1);
    }
    f1b(handler) {
      return invokeOnCancellation(this, new UserSupplied(handler));
    }
    l19(handler) {
      return invokeOnCancellationImpl(this, handler);
    }
    g1b(proposedUpdate, resumeMode, onCancellation) {
      // Inline function 'kotlinx.atomicfu.loop' call
      var this_0 = this.j19_1;
      while (true) {
        var tmp1 = this_0.kotlinx$atomicfu$value;
        $l$block: {
          // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.resumeImpl.<anonymous>' call
          if (!(tmp1 == null) ? isInterface(tmp1, NotCompleted) : false) {
            var update = resumedState(this, tmp1, proposedUpdate, resumeMode, onCancellation, null);
            if (!this.j19_1.atomicfu$compareAndSet(tmp1, update)) {
              break $l$block;
            }
            detachChildIfNonReusable(this);
            dispatchResume(this, resumeMode);
            return Unit_instance;
          } else {
            if (tmp1 instanceof CancelledContinuation) {
              if (tmp1.k1b()) {
                if (onCancellation == null)
                  null;
                else {
                  // Inline function 'kotlin.let' call
                  // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.resumeImpl.<anonymous>.<anonymous>' call
                  this.x1a(onCancellation, tmp1.j1a_1, proposedUpdate);
                }
                return Unit_instance;
              }
            }
          }
          alreadyResumedError(this, proposedUpdate);
        }
      }
    }
    e1b(proposedUpdate, resumeMode, onCancellation, $super) {
      onCancellation = onCancellation === VOID ? null : onCancellation;
      var tmp;
      if ($super === VOID) {
        this.g1b(proposedUpdate, resumeMode, onCancellation);
        tmp = Unit_instance;
      } else {
        tmp = $super.g1b.call(this, proposedUpdate, resumeMode, onCancellation);
      }
      return tmp;
    }
    m1a() {
      var tmp0_elvis_lhs = _get_parentHandle__f8dcex(this);
      var tmp;
      if (tmp0_elvis_lhs == null) {
        return Unit_instance;
      } else {
        tmp = tmp0_elvis_lhs;
      }
      var handle = tmp;
      handle.q1a();
      this.k19_1.kotlinx$atomicfu$value = NonDisposableHandle_instance;
    }
    c1b(state) {
      var tmp;
      if (state instanceof CompletedContinuation) {
        var tmp_0 = state.b1a_1;
        tmp = (tmp_0 == null ? true : !(tmp_0 == null)) ? tmp_0 : THROW_CCE();
      } else {
        tmp = (state == null ? true : !(state == null)) ? state : THROW_CCE();
      }
      return tmp;
    }
    l1b(state) {
      var tmp0_safe_receiver = super.l1b(state);
      var tmp;
      if (tmp0_safe_receiver == null) {
        tmp = null;
      } else {
        // Inline function 'kotlin.let' call
        // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.getExceptionalResult.<anonymous>' call
        tmp = recoverStackTrace(tmp0_safe_receiver, this.g19_1);
      }
      return tmp;
    }
    toString() {
      return this.m1b() + '(' + toDebugString(this.g19_1) + '){' + _get_stateDebugRepresentation__bf18u4(this) + '}@' + get_hexAddress(this);
    }
    m1b() {
      return 'CancellableContinuation';
    }
  }
  class NotCompleted {}
  class CancelHandler {}
  class UserSupplied {
    constructor(handler) {
      this.o1b_1 = handler;
    }
    w1a(cause) {
      this.o1b_1(cause);
    }
    toString() {
      return 'CancelHandler.UserSupplied[' + get_classSimpleName(this.o1b_1) + '@' + get_hexAddress(this) + ']';
    }
  }
  class Active {
    toString() {
      return 'Active';
    }
  }
  class CompletedContinuation {
    constructor(result, cancelHandler, onCancellation, idempotentResume, cancelCause) {
      cancelHandler = cancelHandler === VOID ? null : cancelHandler;
      onCancellation = onCancellation === VOID ? null : onCancellation;
      idempotentResume = idempotentResume === VOID ? null : idempotentResume;
      cancelCause = cancelCause === VOID ? null : cancelCause;
      this.b1a_1 = result;
      this.c1a_1 = cancelHandler;
      this.d1a_1 = onCancellation;
      this.e1a_1 = idempotentResume;
      this.f1a_1 = cancelCause;
    }
    h1a() {
      return !(this.f1a_1 == null);
    }
    t1a(cont, cause) {
      var tmp0_safe_receiver = this.c1a_1;
      if (tmp0_safe_receiver == null)
        null;
      else {
        // Inline function 'kotlin.let' call
        // Inline function 'kotlinx.coroutines.CompletedContinuation.invokeHandlers.<anonymous>' call
        cont.g1a(tmp0_safe_receiver, cause);
      }
      var tmp1_safe_receiver = this.d1a_1;
      if (tmp1_safe_receiver == null)
        null;
      else {
        // Inline function 'kotlin.let' call
        // Inline function 'kotlinx.coroutines.CompletedContinuation.invokeHandlers.<anonymous>' call
        cont.x1a(tmp1_safe_receiver, cause, this.b1a_1);
      }
    }
    p1b(result, cancelHandler, onCancellation, idempotentResume, cancelCause) {
      return new CompletedContinuation(result, cancelHandler, onCancellation, idempotentResume, cancelCause);
    }
    i1a(result, cancelHandler, onCancellation, idempotentResume, cancelCause, $super) {
      result = result === VOID ? this.b1a_1 : result;
      cancelHandler = cancelHandler === VOID ? this.c1a_1 : cancelHandler;
      onCancellation = onCancellation === VOID ? this.d1a_1 : onCancellation;
      idempotentResume = idempotentResume === VOID ? this.e1a_1 : idempotentResume;
      cancelCause = cancelCause === VOID ? this.f1a_1 : cancelCause;
      return $super === VOID ? this.p1b(result, cancelHandler, onCancellation, idempotentResume, cancelCause) : $super.p1b.call(this, result, cancelHandler, onCancellation, idempotentResume, cancelCause);
    }
    toString() {
      return 'CompletedContinuation(result=' + toString_0(this.b1a_1) + ', cancelHandler=' + toString_0(this.c1a_1) + ', onCancellation=' + toString_0(this.d1a_1) + ', idempotentResume=' + toString_0(this.e1a_1) + ', cancelCause=' + toString_0(this.f1a_1) + ')';
    }
    hashCode() {
      var result = this.b1a_1 == null ? 0 : hashCode(this.b1a_1);
      result = imul(result, 31) + (this.c1a_1 == null ? 0 : hashCode(this.c1a_1)) | 0;
      result = imul(result, 31) + (this.d1a_1 == null ? 0 : hashCode(this.d1a_1)) | 0;
      result = imul(result, 31) + (this.e1a_1 == null ? 0 : hashCode(this.e1a_1)) | 0;
      result = imul(result, 31) + (this.f1a_1 == null ? 0 : hashCode(this.f1a_1)) | 0;
      return result;
    }
    equals(other) {
      if (this === other)
        return true;
      if (!(other instanceof CompletedContinuation))
        return false;
      var tmp0_other_with_cast = other instanceof CompletedContinuation ? other : THROW_CCE();
      if (!equals(this.b1a_1, tmp0_other_with_cast.b1a_1))
        return false;
      if (!equals(this.c1a_1, tmp0_other_with_cast.c1a_1))
        return false;
      if (!equals(this.d1a_1, tmp0_other_with_cast.d1a_1))
        return false;
      if (!equals(this.e1a_1, tmp0_other_with_cast.e1a_1))
        return false;
      if (!equals(this.f1a_1, tmp0_other_with_cast.f1a_1))
        return false;
      return true;
    }
  }
  class LockFreeLinkedListNode {
    constructor() {
      this.c1c_1 = this;
      this.d1c_1 = this;
      this.e1c_1 = false;
    }
    f1c(node, permissionsBitmask) {
      var prev = this.d1c_1;
      var tmp;
      if (prev instanceof ListClosed) {
        tmp = ((prev.g1e_1 & permissionsBitmask) === 0 && prev.f1c(node, permissionsBitmask));
      } else {
        node.c1c_1 = this;
        node.d1c_1 = prev;
        prev.c1c_1 = node;
        this.d1c_1 = node;
        tmp = true;
      }
      return tmp;
    }
    g1c() {
      if (this.e1c_1)
        return false;
      var prev = this.d1c_1;
      var next = this.c1c_1;
      prev.c1c_1 = next;
      next.d1c_1 = prev;
      this.e1c_1 = true;
      return true;
    }
    h1c(node) {
      if (!(this.c1c_1 === this))
        return false;
      this.f1c(node, -2147483648);
      return true;
    }
  }
  class Incomplete {}
  class JobNode extends LockFreeLinkedListNode {
    a1c() {
      var tmp = this.z1b_1;
      if (!(tmp == null))
        return tmp;
      else {
        throwUninitializedPropertyAccessException('job');
      }
    }
    b1c() {
      return null;
    }
    q1a() {
      return this.a1c().p1d(this);
    }
    toString() {
      return get_classSimpleName(this) + '@' + get_hexAddress(this) + '[job@' + get_hexAddress(this.a1c()) + ']';
    }
  }
  class ChildContinuation extends JobNode {
    constructor(child) {
      super();
      this.u1b_1 = child;
    }
    v1b() {
      return true;
    }
    w1a(cause) {
      this.u1b_1.v1a(this.u1b_1.y1a(this.a1c()));
    }
  }
  class CompletedExceptionally {
    constructor(cause, handled) {
      handled = handled === VOID ? false : handled;
      this.j1a_1 = cause;
      this.k1a_1 = atomic$boolean$1(handled);
    }
    l1a() {
      return this.k1a_1.atomicfu$compareAndSet(false, true);
    }
    toString() {
      return get_classSimpleName(this) + '[' + this.j1a_1.toString() + ']';
    }
  }
  class CancelledContinuation extends CompletedExceptionally {
    constructor(continuation, cause, handled) {
      super(cause == null ? CancellationException.mc('Continuation ' + toString(continuation) + ' was cancelled normally') : cause, handled);
      this.j1b_1 = atomic$boolean$1(false);
    }
    k1b() {
      return this.j1b_1.atomicfu$compareAndSet(false, true);
    }
  }
  class Key extends AbstractCoroutineContextKey {
    constructor() {
      Key_instance_0 = null;
      var tmp = Key_instance;
      super(tmp, CoroutineDispatcher$Key$_init_$lambda_akl8b5);
      Key_instance_0 = this;
    }
  }
  class CoroutineDispatcher extends AbstractCoroutineContextElement {
    constructor() {
      Key_getInstance();
      super(Key_instance);
    }
    j1c(context) {
      return true;
    }
    fc(continuation) {
      return new DispatchedContinuation(this, continuation);
    }
    toString() {
      return get_classSimpleName(this) + '@' + get_hexAddress(this);
    }
  }
  class Key_0 {}
  class EventLoop extends CoroutineDispatcher {
    constructor() {
      super();
      this.q1c_1 = new Long(0, 0);
      this.r1c_1 = false;
      this.s1c_1 = null;
    }
    t1c() {
      var tmp0_elvis_lhs = this.s1c_1;
      var tmp;
      if (tmp0_elvis_lhs == null) {
        return false;
      } else {
        tmp = tmp0_elvis_lhs;
      }
      var queue = tmp;
      var tmp1_elvis_lhs = queue.jg();
      var tmp_0;
      if (tmp1_elvis_lhs == null) {
        return false;
      } else {
        tmp_0 = tmp1_elvis_lhs;
      }
      var task = tmp_0;
      task.y17();
      return true;
    }
    u1c(task) {
      var tmp0_elvis_lhs = this.s1c_1;
      var tmp;
      if (tmp0_elvis_lhs == null) {
        // Inline function 'kotlin.also' call
        var this_0 = ArrayDeque.fg();
        // Inline function 'kotlinx.coroutines.EventLoop.dispatchUnconfined.<anonymous>' call
        this.s1c_1 = this_0;
        tmp = this_0;
      } else {
        tmp = tmp0_elvis_lhs;
      }
      var queue = tmp;
      queue.hg(task);
    }
    v1c() {
      return this.q1c_1.m1(delta(this, true)) >= 0;
    }
    w1c() {
      var tmp0_safe_receiver = this.s1c_1;
      var tmp1_elvis_lhs = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.c1();
      return tmp1_elvis_lhs == null ? true : tmp1_elvis_lhs;
    }
    x1c(unconfined) {
      this.q1c_1 = this.q1c_1.h3(delta(this, unconfined));
      if (!unconfined)
        this.r1c_1 = true;
    }
    y1c(unconfined) {
      this.q1c_1 = this.q1c_1.i3(delta(this, unconfined));
      if (this.q1c_1.m1(new Long(0, 0)) > 0)
        return Unit_instance;
      // Inline function 'kotlinx.coroutines.assert' call
      if (this.r1c_1) {
        this.z1c();
      }
    }
    z1c() {
    }
  }
  class ThreadLocalEventLoop {
    constructor() {
      ThreadLocalEventLoop_instance = this;
      this.a1d_1 = commonThreadLocal(new Symbol('ThreadLocalEventLoop'));
    }
    b1d() {
      var tmp0_elvis_lhs = this.a1d_1.yk();
      var tmp;
      if (tmp0_elvis_lhs == null) {
        // Inline function 'kotlin.also' call
        var this_0 = createEventLoop();
        // Inline function 'kotlinx.coroutines.ThreadLocalEventLoop.<get-eventLoop>.<anonymous>' call
        ThreadLocalEventLoop_getInstance().a1d_1.d1d(this_0);
        tmp = this_0;
      } else {
        tmp = tmp0_elvis_lhs;
      }
      return tmp;
    }
  }
  class CompletionHandlerException extends RuntimeException {
    static a1a(message, cause) {
      var $this = this.rc(message, cause);
      captureStack($this, $this.z19_1);
      return $this;
    }
  }
  class CoroutinesInternalError extends Error_0 {
    static g1d(message, cause) {
      var $this = this.wc(message, cause);
      captureStack($this, $this.f1d_1);
      return $this;
    }
  }
  class Key_1 {}
  class NonDisposableHandle {
    q1a() {
    }
    toString() {
      return 'NonDisposableHandle';
    }
  }
  class Empty {
    constructor(isActive) {
      this.k1d_1 = isActive;
    }
    b1c() {
      return null;
    }
    toString() {
      return 'Empty{' + (this.k1d_1 ? 'Active' : 'New') + '}';
    }
  }
  class LockFreeLinkedListHead extends LockFreeLinkedListNode {}
  class NodeList extends LockFreeLinkedListHead {
    b1c() {
      return this;
    }
    o1d(state) {
      // Inline function 'kotlin.text.buildString' call
      // Inline function 'kotlin.apply' call
      var this_0 = StringBuilder.u();
      // Inline function 'kotlinx.coroutines.NodeList.getString.<anonymous>' call
      this_0.lb('List{');
      this_0.lb(state);
      this_0.lb('}[');
      var first = true;
      // Inline function 'kotlinx.coroutines.internal.LockFreeLinkedListHead.forEach' call
      var cur = this.c1c_1;
      while (!equals(cur, this)) {
        // Inline function 'kotlinx.coroutines.NodeList.getString.<anonymous>.<anonymous>' call
        var node = cur;
        if (node instanceof JobNode) {
          if (first) {
            first = false;
          } else
            this_0.lb(', ');
          this_0.kb(node);
        }
        cur = cur.c1c_1;
      }
      this_0.lb(']');
      return this_0.toString();
    }
    toString() {
      return get_DEBUG() ? this.o1d('Active') : super.toString();
    }
  }
  class SynchronizedObject {}
  class Finishing extends SynchronizedObject {
    r1d() {
      return this.q1d_1.kotlinx$atomicfu$value;
    }
  }
  class JobSupport {
    m19() {
      return this.i1d_1.kotlinx$atomicfu$value;
    }
    j1d(invokeImmediately, node) {
      node.z1b_1 = this;
      var tmp$ret$0;
      $l$block_1: {
        // Inline function 'kotlinx.coroutines.JobSupport.tryPutNodeIntoList' call
        // Inline function 'kotlinx.coroutines.JobSupport.loopOnState' call
        while (true) {
          // Inline function 'kotlinx.coroutines.JobSupport.tryPutNodeIntoList.<anonymous>' call
          var state = this.m19();
          if (state instanceof Empty) {
            if (state.k1d_1) {
              if (this.i1d_1.atomicfu$compareAndSet(state, node)) {
                tmp$ret$0 = true;
                break $l$block_1;
              }
            } else {
              promoteEmptyToNodeList(this, state);
            }
          } else {
            if (!(state == null) ? isInterface(state, Incomplete) : false) {
              var list = state.b1c();
              if (list == null) {
                promoteSingleToNodeList(this, state instanceof JobNode ? state : THROW_CCE());
              } else {
                // Inline function 'kotlinx.coroutines.JobSupport.invokeOnCompletionInternal.<anonymous>' call
                var tmp;
                if (node.v1b()) {
                  var tmp0_safe_receiver = state instanceof Finishing ? state : null;
                  var rootCause = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.r1d();
                  var tmp_0;
                  if (rootCause == null) {
                    tmp_0 = list.f1c(node, 5);
                  } else {
                    if (invokeImmediately) {
                      node.w1a(rootCause);
                    }
                    return NonDisposableHandle_instance;
                  }
                  tmp = tmp_0;
                } else {
                  tmp = list.f1c(node, 1);
                }
                if (tmp) {
                  tmp$ret$0 = true;
                  break $l$block_1;
                }
              }
            } else {
              tmp$ret$0 = false;
              break $l$block_1;
            }
          }
        }
      }
      var added = tmp$ret$0;
      if (added)
        return node;
      else if (invokeImmediately) {
        var tmp_1 = this.m19();
        var tmp0_safe_receiver_0 = tmp_1 instanceof CompletedExceptionally ? tmp_1 : null;
        node.w1a(tmp0_safe_receiver_0 == null ? null : tmp0_safe_receiver_0.j1a_1);
      }
      return NonDisposableHandle_instance;
    }
    p1d(node) {
      // Inline function 'kotlinx.coroutines.JobSupport.loopOnState' call
      while (true) {
        // Inline function 'kotlinx.coroutines.JobSupport.removeNode.<anonymous>' call
        var state = this.m19();
        if (state instanceof JobNode) {
          if (!(state === node))
            return Unit_instance;
          if (this.i1d_1.atomicfu$compareAndSet(state, get_EMPTY_ACTIVE()))
            return Unit_instance;
        } else {
          if (!(state == null) ? isInterface(state, Incomplete) : false) {
            if (!(state.b1c() == null)) {
              node.g1c();
            }
            return Unit_instance;
          } else {
            return Unit_instance;
          }
        }
      }
    }
  }
  class InactiveNodeList {
    constructor(list) {
      this.s1d_1 = list;
    }
    b1c() {
      return this.s1d_1;
    }
    toString() {
      return get_DEBUG() ? this.s1d_1.o1d('New') : anyToString(this);
    }
  }
  class ConcurrentLinkedListNode {}
  class Segment extends ConcurrentLinkedListNode {}
  class ExceptionSuccessfullyProcessed extends Exception {}
  class DispatchedContinuation extends DispatchedTask {
    constructor(dispatcher, continuation) {
      super(-1);
      this.o19_1 = dispatcher;
      this.p19_1 = continuation;
      this.q19_1 = get_UNDEFINED();
      this.r19_1 = threadContextElements(this.dc());
      this.s19_1 = atomic$ref$1(null);
    }
    t19() {
      return !(this.s19_1.kotlinx$atomicfu$value == null);
    }
    d1b(continuation) {
      // Inline function 'kotlinx.atomicfu.loop' call
      var this_0 = this.s19_1;
      while (true) {
        // Inline function 'kotlinx.coroutines.internal.DispatchedContinuation.tryReleaseClaimedContinuation.<anonymous>' call
        var state = this_0.kotlinx$atomicfu$value;
        if (state === get_REUSABLE_CLAIMED()) {
          if (this.s19_1.atomicfu$compareAndSet(get_REUSABLE_CLAIMED(), continuation))
            return null;
        } else {
          if (state instanceof Error) {
            // Inline function 'kotlin.require' call
            // Inline function 'kotlin.require' call
            if (!this.s19_1.atomicfu$compareAndSet(state, null)) {
              // Inline function 'kotlin.require.<anonymous>' call
              var message = 'Failed requirement.';
              throw IllegalArgumentException.h(toString(message));
            }
            return state;
          } else {
            // Inline function 'kotlin.error' call
            var message_0 = 'Inconsistent state ' + toString_0(state);
            throw IllegalStateException.n4(toString(message_0));
          }
        }
      }
    }
    v19(cause) {
      // Inline function 'kotlinx.atomicfu.loop' call
      var this_0 = this.s19_1;
      while (true) {
        // Inline function 'kotlinx.coroutines.internal.DispatchedContinuation.postponeCancellation.<anonymous>' call
        var state = this_0.kotlinx$atomicfu$value;
        if (equals(state, get_REUSABLE_CLAIMED())) {
          if (this.s19_1.atomicfu$compareAndSet(get_REUSABLE_CLAIMED(), cause))
            return true;
        } else {
          if (state instanceof Error)
            return true;
          else {
            if (this.s19_1.atomicfu$compareAndSet(state, null))
              return false;
          }
        }
      }
    }
    r1a() {
      var state = this.q19_1;
      // Inline function 'kotlinx.coroutines.assert' call
      this.q19_1 = get_UNDEFINED();
      return state;
    }
    n1a() {
      return this;
    }
    fh(result) {
      var state = toState_0(result);
      if (safeIsDispatchNeeded(this.o19_1, this.dc())) {
        this.q19_1 = state;
        this.u19_1 = 0;
        safeDispatch(this.o19_1, this.dc(), this);
      } else {
        $l$block: {
          // Inline function 'kotlinx.coroutines.internal.executeUnconfined' call
          // Inline function 'kotlinx.coroutines.assert' call
          var eventLoop = ThreadLocalEventLoop_getInstance().b1d();
          if (false && eventLoop.w1c()) {
            break $l$block;
          }
          var tmp;
          if (eventLoop.v1c()) {
            this.q19_1 = state;
            this.u19_1 = 0;
            eventLoop.u1c(this);
            tmp = true;
          } else {
            // Inline function 'kotlinx.coroutines.runUnconfinedEventLoop' call
            eventLoop.x1c(true);
            try {
              // Inline function 'kotlinx.coroutines.internal.DispatchedContinuation.resumeWith.<anonymous>' call
              this.dc();
              // Inline function 'kotlinx.coroutines.withCoroutineContext' call
              this.r19_1;
              // Inline function 'kotlinx.coroutines.internal.DispatchedContinuation.resumeWith.<anonymous>.<anonymous>' call
              this.p19_1.fh(result);
              $l$loop: while (eventLoop.t1c()) {
              }
            } catch ($p) {
              if ($p instanceof Error) {
                var e = $p;
                this.n1b(e);
              } else {
                throw $p;
              }
            }
            finally {
              eventLoop.y1c(true);
            }
            tmp = false;
          }
        }
      }
    }
    toString() {
      return 'DispatchedContinuation[' + this.o19_1.toString() + ', ' + toDebugString(this.p19_1) + ']';
    }
    dc() {
      return this.p19_1.dc();
    }
  }
  class DispatchException extends Exception {
    static x1d(cause, dispatcher, context) {
      var $this = this.oc('Coroutine dispatcher ' + dispatcher.toString() + ' threw an exception, context = ' + toString(context), cause);
      captureStack($this, $this.n1c_1);
      $this.m1c_1 = cause;
      return $this;
    }
    w1() {
      return this.m1c_1;
    }
    get cause() {
      return this.w1();
    }
  }
  class Symbol {
    constructor(symbol) {
      this.y1d_1 = symbol;
    }
    toString() {
      return '<' + this.y1d_1 + '>';
    }
  }
  class UnconfinedEventLoop extends EventLoop {
    k1c(context, block) {
      unsupported();
    }
  }
  class DiagnosticCoroutineContextException extends RuntimeException {
    static w1d(context) {
      var $this = this.ja(toString(context));
      captureStack($this, $this.v1d_1);
      return $this;
    }
  }
  class ListClosed extends LockFreeLinkedListNode {}
  class CommonThreadLocal {
    constructor() {
      this.c1d_1 = null;
    }
    yk() {
      var tmp = this.c1d_1;
      return (tmp == null ? true : !(tmp == null)) ? tmp : THROW_CCE();
    }
    d1d(value) {
      this.c1d_1 = value;
    }
  }
  //endregion
  function invokeOnCancellation(_this__u8e3s4, handler) {
    var tmp;
    if (_this__u8e3s4 instanceof CancellableContinuationImpl) {
      _this__u8e3s4.l19(handler);
      tmp = Unit_instance;
    } else {
      throw UnsupportedOperationException.t9('third-party implementation of CancellableContinuation is not supported');
    }
    return tmp;
  }
  function _get_parentHandle__f8dcex($this) {
    return $this.k19_1.kotlinx$atomicfu$value;
  }
  function _get_stateDebugRepresentation__bf18u4($this) {
    var tmp0_subject = $this.m19();
    var tmp;
    if (!(tmp0_subject == null) ? isInterface(tmp0_subject, NotCompleted) : false) {
      tmp = 'Active';
    } else {
      if (tmp0_subject instanceof CancelledContinuation) {
        tmp = 'Cancelled';
      } else {
        tmp = 'Completed';
      }
    }
    return tmp;
  }
  function isReusable($this) {
    var tmp;
    if (get_isReusableMode($this.u19_1)) {
      var tmp_0 = $this.g19_1;
      tmp = (tmp_0 instanceof DispatchedContinuation ? tmp_0 : THROW_CCE()).t19();
    } else {
      tmp = false;
    }
    return tmp;
  }
  function cancelLater($this, cause) {
    if (!isReusable($this))
      return false;
    var tmp = $this.g19_1;
    var dispatched = tmp instanceof DispatchedContinuation ? tmp : THROW_CCE();
    return dispatched.v19(cause);
  }
  function callSegmentOnCancellation($this, segment, cause) {
    // Inline function 'kotlinx.coroutines.index' call
    var index = $this.i19_1.kotlinx$atomicfu$value & 536870911;
    // Inline function 'kotlin.check' call
    if (!!(index === 536870911)) {
      // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.callSegmentOnCancellation.<anonymous>' call
      var message = 'The index for Segment.onCancellation(..) is broken';
      throw IllegalStateException.n4(toString(message));
    }
    // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.callCancelHandlerSafely' call
    try {
      // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.callSegmentOnCancellation.<anonymous>' call
      segment.w19(index, cause, $this.dc());
    } catch ($p) {
      if ($p instanceof Error) {
        var ex = $p;
        handleCoroutineException($this.dc(), CompletionHandlerException.a1a('Exception in invokeOnCancellation handler for ' + $this.toString(), ex));
      } else {
        throw $p;
      }
    }
  }
  function trySuspend($this) {
    // Inline function 'kotlinx.atomicfu.loop' call
    var this_0 = $this.i19_1;
    while (true) {
      // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.trySuspend.<anonymous>' call
      var cur = this_0.kotlinx$atomicfu$value;
      // Inline function 'kotlinx.coroutines.decision' call
      switch (cur >> 29) {
        case 0:
          // Inline function 'kotlinx.coroutines.index' call

          // Inline function 'kotlinx.coroutines.decisionAndIndex' call

          var tmp$ret$2 = (1 << 29) + (cur & 536870911) | 0;
          if ($this.i19_1.atomicfu$compareAndSet(cur, tmp$ret$2))
            return true;
          break;
        case 2:
          return false;
        default:
          // Inline function 'kotlin.error' call

          var message = 'Already suspended';
          throw IllegalStateException.n4(toString(message));
      }
    }
  }
  function tryResume($this) {
    // Inline function 'kotlinx.atomicfu.loop' call
    var this_0 = $this.i19_1;
    while (true) {
      // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.tryResume.<anonymous>' call
      var cur = this_0.kotlinx$atomicfu$value;
      // Inline function 'kotlinx.coroutines.decision' call
      switch (cur >> 29) {
        case 0:
          // Inline function 'kotlinx.coroutines.index' call

          // Inline function 'kotlinx.coroutines.decisionAndIndex' call

          var tmp$ret$2 = (2 << 29) + (cur & 536870911) | 0;
          if ($this.i19_1.atomicfu$compareAndSet(cur, tmp$ret$2))
            return true;
          break;
        case 1:
          return false;
        default:
          // Inline function 'kotlin.error' call

          var message = 'Already resumed';
          throw IllegalStateException.n4(toString(message));
      }
    }
  }
  function installParentHandle($this) {
    var tmp0_elvis_lhs = $this.dc().ec(Key_instance_2);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return null;
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var parent = tmp;
    var handle = invokeOnCompletion(parent, VOID, new ChildContinuation($this));
    $this.k19_1.atomicfu$compareAndSet(null, handle);
    return handle;
  }
  function invokeOnCancellationImpl($this, handler) {
    // Inline function 'kotlinx.coroutines.assert' call
    // Inline function 'kotlinx.atomicfu.loop' call
    var this_0 = $this.j19_1;
    while (true) {
      // Inline function 'kotlinx.coroutines.CancellableContinuationImpl.invokeOnCancellationImpl.<anonymous>' call
      var state = this_0.kotlinx$atomicfu$value;
      if (state instanceof Active) {
        if ($this.j19_1.atomicfu$compareAndSet(state, handler))
          return Unit_instance;
      } else {
        var tmp;
        if (!(state == null) ? isInterface(state, CancelHandler) : false) {
          tmp = true;
        } else {
          tmp = state instanceof Segment;
        }
        if (tmp) {
          multipleHandlersError($this, handler, state);
        } else {
          if (state instanceof CompletedExceptionally) {
            if (!state.l1a()) {
              multipleHandlersError($this, handler, state);
            }
            if (state instanceof CancelledContinuation) {
              var tmp1_safe_receiver = state instanceof CompletedExceptionally ? state : null;
              var cause = tmp1_safe_receiver == null ? null : tmp1_safe_receiver.j1a_1;
              if (isInterface(handler, CancelHandler)) {
                $this.g1a(handler, cause);
              } else {
                var segment = handler instanceof Segment ? handler : THROW_CCE();
                callSegmentOnCancellation($this, segment, cause);
              }
            }
            return Unit_instance;
          } else {
            if (state instanceof CompletedContinuation) {
              if (!(state.c1a_1 == null)) {
                multipleHandlersError($this, handler, state);
              }
              if (handler instanceof Segment)
                return Unit_instance;
              if (!isInterface(handler, CancelHandler))
                THROW_CCE();
              if (state.h1a()) {
                $this.g1a(handler, state.f1a_1);
                return Unit_instance;
              }
              var update = state.i1a(VOID, handler);
              if ($this.j19_1.atomicfu$compareAndSet(state, update))
                return Unit_instance;
            } else {
              if (handler instanceof Segment)
                return Unit_instance;
              if (!isInterface(handler, CancelHandler))
                THROW_CCE();
              var update_0 = new CompletedContinuation(state, handler);
              if ($this.j19_1.atomicfu$compareAndSet(state, update_0))
                return Unit_instance;
            }
          }
        }
      }
    }
  }
  function multipleHandlersError($this, handler, state) {
    // Inline function 'kotlin.error' call
    var message = "It's prohibited to register multiple handlers, tried to register " + toString(handler) + ', already has ' + toString_0(state);
    throw IllegalStateException.n4(toString(message));
  }
  function dispatchResume($this, mode) {
    if (tryResume($this))
      return Unit_instance;
    dispatch($this, mode);
  }
  function resumedState($this, state, proposedUpdate, resumeMode, onCancellation, idempotent) {
    var tmp;
    if (proposedUpdate instanceof CompletedExceptionally) {
      // Inline function 'kotlinx.coroutines.assert' call
      // Inline function 'kotlinx.coroutines.assert' call
      tmp = proposedUpdate;
    } else {
      if (!get_isCancellableMode(resumeMode) && idempotent == null) {
        tmp = proposedUpdate;
      } else {
        var tmp_0;
        var tmp_1;
        if (!(onCancellation == null)) {
          tmp_1 = true;
        } else {
          tmp_1 = isInterface(state, CancelHandler);
        }
        if (tmp_1) {
          tmp_0 = true;
        } else {
          tmp_0 = !(idempotent == null);
        }
        if (tmp_0) {
          tmp = new CompletedContinuation(proposedUpdate, isInterface(state, CancelHandler) ? state : null, onCancellation, idempotent);
        } else {
          tmp = proposedUpdate;
        }
      }
    }
    return tmp;
  }
  function alreadyResumedError($this, proposedUpdate) {
    // Inline function 'kotlin.error' call
    var message = 'Already resumed, but proposed with update ' + toString_0(proposedUpdate);
    throw IllegalStateException.n4(toString(message));
  }
  function detachChildIfNonReusable($this) {
    if (!isReusable($this)) {
      $this.m1a();
    }
  }
  var Active_instance;
  function Active_getInstance() {
    return Active_instance;
  }
  function toState(_this__u8e3s4, caller) {
    // Inline function 'kotlin.getOrElse' call
    var exception = Result__exceptionOrNull_impl_p6xea9(_this__u8e3s4);
    var tmp;
    if (exception == null) {
      var tmp_0 = _Result___get_value__impl__bjfvqg(_this__u8e3s4);
      tmp = (tmp_0 == null ? true : !(tmp_0 == null)) ? tmp_0 : THROW_CCE();
    } else {
      // Inline function 'kotlinx.coroutines.toState.<anonymous>' call
      tmp = new CompletedExceptionally(recoverStackTrace(exception, caller));
    }
    return tmp;
  }
  function toState_0(_this__u8e3s4) {
    // Inline function 'kotlin.getOrElse' call
    var exception = Result__exceptionOrNull_impl_p6xea9(_this__u8e3s4);
    var tmp;
    if (exception == null) {
      var tmp_0 = _Result___get_value__impl__bjfvqg(_this__u8e3s4);
      tmp = (tmp_0 == null ? true : !(tmp_0 == null)) ? tmp_0 : THROW_CCE();
    } else {
      // Inline function 'kotlinx.coroutines.toState.<anonymous>' call
      tmp = new CompletedExceptionally(exception);
    }
    return tmp;
  }
  function CoroutineDispatcher$Key$_init_$lambda_akl8b5(it) {
    return it instanceof CoroutineDispatcher ? it : null;
  }
  var Key_instance_0;
  function Key_getInstance() {
    if (Key_instance_0 === VOID)
      new Key();
    return Key_instance_0;
  }
  function handleCoroutineException(context, exception) {
    var tmp;
    if (exception instanceof DispatchException) {
      tmp = exception.m1c_1;
    } else {
      tmp = exception;
    }
    var reportException = tmp;
    try {
      var tmp0_safe_receiver = context.ec(Key_instance_1);
      if (tmp0_safe_receiver == null)
        null;
      else {
        // Inline function 'kotlin.let' call
        tmp0_safe_receiver.o1c(context, reportException);
        return Unit_instance;
      }
    } catch ($p) {
      if ($p instanceof Error) {
        var t = $p;
        handleUncaughtCoroutineException(context, handlerException(reportException, t));
        return Unit_instance;
      } else {
        throw $p;
      }
    }
    handleUncaughtCoroutineException(context, reportException);
  }
  var Key_instance_1;
  function Key_getInstance_0() {
    return Key_instance_1;
  }
  function handlerException(originalException, thrownException) {
    if (originalException === thrownException)
      return originalException;
    // Inline function 'kotlin.apply' call
    var this_0 = RuntimeException.rc('Exception while trying to handle coroutine exception', thrownException);
    // Inline function 'kotlinx.coroutines.handlerException.<anonymous>' call
    addSuppressed(this_0, originalException);
    return this_0;
  }
  function delta($this, unconfined) {
    return unconfined ? new Long(0, 1) : new Long(1, 0);
  }
  var ThreadLocalEventLoop_instance;
  function ThreadLocalEventLoop_getInstance() {
    if (ThreadLocalEventLoop_instance === VOID)
      new ThreadLocalEventLoop();
    return ThreadLocalEventLoop_instance;
  }
  var Key_instance_2;
  function Key_getInstance_1() {
    return Key_instance_2;
  }
  var NonDisposableHandle_instance;
  function NonDisposableHandle_getInstance() {
    return NonDisposableHandle_instance;
  }
  function invokeOnCompletion(_this__u8e3s4, invokeImmediately, handler) {
    invokeImmediately = invokeImmediately === VOID ? true : invokeImmediately;
    var tmp;
    if (_this__u8e3s4 instanceof JobSupport) {
      tmp = _this__u8e3s4.j1d(invokeImmediately, handler);
    } else {
      var tmp_0 = handler.v1b();
      tmp = _this__u8e3s4.h1d(tmp_0, invokeImmediately, JobNode$invoke$ref(handler));
    }
    return tmp;
  }
  function JobNode$invoke$ref($boundThis) {
    var l = function (p0) {
      $boundThis.w1a(p0);
      return Unit_instance;
    };
    l.callableName = 'invoke';
    return l;
  }
  var COMPLETING_ALREADY;
  var COMPLETING_WAITING_CHILDREN;
  var COMPLETING_RETRY;
  var TOO_LATE_TO_CANCEL;
  var SEALED;
  var EMPTY_NEW;
  function get_EMPTY_ACTIVE() {
    _init_properties_JobSupport_kt__68f172();
    return EMPTY_ACTIVE;
  }
  var EMPTY_ACTIVE;
  function promoteEmptyToNodeList($this, state) {
    var list = new NodeList();
    var update = state.k1d_1 ? list : new InactiveNodeList(list);
    $this.i1d_1.atomicfu$compareAndSet(state, update);
  }
  function promoteSingleToNodeList($this, state) {
    state.h1c(new NodeList());
    // Inline function 'kotlinx.coroutines.internal.LockFreeLinkedListNode.nextNode' call
    var list = state.c1c_1;
    $this.i1d_1.atomicfu$compareAndSet(state, list);
  }
  var properties_initialized_JobSupport_kt_5iq8a4;
  function _init_properties_JobSupport_kt__68f172() {
    if (!properties_initialized_JobSupport_kt_5iq8a4) {
      properties_initialized_JobSupport_kt_5iq8a4 = true;
      COMPLETING_ALREADY = new Symbol('COMPLETING_ALREADY');
      COMPLETING_WAITING_CHILDREN = new Symbol('COMPLETING_WAITING_CHILDREN');
      COMPLETING_RETRY = new Symbol('COMPLETING_RETRY');
      TOO_LATE_TO_CANCEL = new Symbol('TOO_LATE_TO_CANCEL');
      SEALED = new Symbol('SEALED');
      EMPTY_NEW = new Empty(false);
      EMPTY_ACTIVE = new Empty(true);
    }
  }
  function handleUncaughtCoroutineException(context, exception) {
    var _iterator__ex2g4s = get_platformExceptionHandlers().x();
    while (_iterator__ex2g4s.y()) {
      var handler = _iterator__ex2g4s.z();
      try {
        handler.o1c(context, exception);
      } catch ($p) {
        if ($p instanceof ExceptionSuccessfullyProcessed) {
          var _unused_var__etf5q3 = $p;
          return Unit_instance;
        } else {
          if ($p instanceof Error) {
            var t = $p;
            propagateExceptionFinalResort(handlerException(exception, t));
          } else {
            throw $p;
          }
        }
      }
    }
    try {
      addSuppressed(exception, DiagnosticCoroutineContextException.w1d(context));
    } catch ($p) {
      if ($p instanceof Error) {
        var e = $p;
      } else {
        throw $p;
      }
    }
    propagateExceptionFinalResort(exception);
  }
  function get_UNDEFINED() {
    _init_properties_DispatchedContinuation_kt__tnmqc0();
    return UNDEFINED;
  }
  var UNDEFINED;
  function get_REUSABLE_CLAIMED() {
    _init_properties_DispatchedContinuation_kt__tnmqc0();
    return REUSABLE_CLAIMED;
  }
  var REUSABLE_CLAIMED;
  function safeDispatch(_this__u8e3s4, context, runnable) {
    _init_properties_DispatchedContinuation_kt__tnmqc0();
    try {
      _this__u8e3s4.k1c(context, runnable);
    } catch ($p) {
      if ($p instanceof Error) {
        var e = $p;
        throw DispatchException.x1d(e, _this__u8e3s4, context);
      } else {
        throw $p;
      }
    }
  }
  function safeIsDispatchNeeded(_this__u8e3s4, context) {
    _init_properties_DispatchedContinuation_kt__tnmqc0();
    try {
      return _this__u8e3s4.j1c(context);
    } catch ($p) {
      if ($p instanceof Error) {
        var e = $p;
        throw DispatchException.x1d(e, _this__u8e3s4, context);
      } else {
        throw $p;
      }
    }
  }
  var properties_initialized_DispatchedContinuation_kt_2siadq;
  function _init_properties_DispatchedContinuation_kt__tnmqc0() {
    if (!properties_initialized_DispatchedContinuation_kt_2siadq) {
      properties_initialized_DispatchedContinuation_kt_2siadq = true;
      UNDEFINED = new Symbol('UNDEFINED');
      REUSABLE_CLAIMED = new Symbol('REUSABLE_CLAIMED');
    }
  }
  function get_isReusableMode(_this__u8e3s4) {
    return _this__u8e3s4 === 2;
  }
  function get_isCancellableMode(_this__u8e3s4) {
    return _this__u8e3s4 === 1 || _this__u8e3s4 === 2;
  }
  function dispatch(_this__u8e3s4, mode) {
    // Inline function 'kotlinx.coroutines.assert' call
    var delegate = _this__u8e3s4.n1a();
    var undispatched = mode === 4;
    var tmp;
    var tmp_0;
    if (!undispatched) {
      tmp_0 = delegate instanceof DispatchedContinuation;
    } else {
      tmp_0 = false;
    }
    if (tmp_0) {
      tmp = get_isCancellableMode(mode) === get_isCancellableMode(_this__u8e3s4.u19_1);
    } else {
      tmp = false;
    }
    if (tmp) {
      var dispatcher = delegate.o19_1;
      var context = delegate.dc();
      if (safeIsDispatchNeeded(dispatcher, context)) {
        safeDispatch(dispatcher, context, _this__u8e3s4);
      } else {
        resumeUnconfined(_this__u8e3s4);
      }
    } else {
      resume(_this__u8e3s4, delegate, undispatched);
    }
  }
  function resumeUnconfined(_this__u8e3s4) {
    var eventLoop = ThreadLocalEventLoop_getInstance().b1d();
    if (eventLoop.v1c()) {
      eventLoop.u1c(_this__u8e3s4);
    } else {
      // Inline function 'kotlinx.coroutines.runUnconfinedEventLoop' call
      eventLoop.x1c(true);
      try {
        // Inline function 'kotlinx.coroutines.resumeUnconfined.<anonymous>' call
        resume(_this__u8e3s4, _this__u8e3s4.n1a(), true);
        $l$loop: while (eventLoop.t1c()) {
        }
      } catch ($p) {
        if ($p instanceof Error) {
          var e = $p;
          _this__u8e3s4.n1b(e);
        } else {
          throw $p;
        }
      }
      finally {
        eventLoop.y1c(true);
      }
    }
  }
  function resume(_this__u8e3s4, delegate, undispatched) {
    var state = _this__u8e3s4.r1a();
    var exception = _this__u8e3s4.l1b(state);
    var tmp;
    if (!(exception == null)) {
      // Inline function 'kotlin.Companion.failure' call
      tmp = _Result___init__impl__xyqfz8(createFailure(exception));
    } else {
      // Inline function 'kotlin.Companion.success' call
      var value = _this__u8e3s4.c1b(state);
      tmp = _Result___init__impl__xyqfz8(value);
    }
    var result = tmp;
    if (undispatched) {
      // Inline function 'kotlinx.coroutines.internal.DispatchedContinuation.resumeUndispatchedWith' call
      var this_0 = delegate instanceof DispatchedContinuation ? delegate : THROW_CCE();
      this_0.p19_1;
      // Inline function 'kotlinx.coroutines.withContinuationContext' call
      this_0.r19_1;
      // Inline function 'kotlinx.coroutines.internal.DispatchedContinuation.resumeUndispatchedWith.<anonymous>' call
      this_0.p19_1.fh(result);
    } else {
      delegate.fh(result);
    }
  }
  var counter;
  function get_DEBUG() {
    return DEBUG;
  }
  var DEBUG;
  function get_classSimpleName(_this__u8e3s4) {
    var tmp0_elvis_lhs = getKClassFromExpression(_this__u8e3s4).td();
    return tmp0_elvis_lhs == null ? 'Unknown' : tmp0_elvis_lhs;
  }
  function get_hexAddress(_this__u8e3s4) {
    // Inline function 'kotlin.js.asDynamic' call
    var result = _this__u8e3s4.__debug_counter;
    if (!(typeof result === 'number')) {
      counter = counter + 1 | 0;
      result = counter;
      // Inline function 'kotlin.js.asDynamic' call
      _this__u8e3s4.__debug_counter = result;
    }
    return ((!(result == null) ? typeof result === 'number' : false) ? result : THROW_CCE()).toString();
  }
  function propagateExceptionFinalResort(exception) {
    console.error(exception.toString());
  }
  function createEventLoop() {
    return new UnconfinedEventLoop();
  }
  function unsupported() {
    throw UnsupportedOperationException.t9('runBlocking event loop is not supported');
  }
  function toDebugString(_this__u8e3s4) {
    return toString(_this__u8e3s4);
  }
  function get_platformExceptionHandlers_() {
    _init_properties_CoroutineExceptionHandlerImpl_kt__37d7wf();
    return platformExceptionHandlers_;
  }
  var platformExceptionHandlers_;
  function get_platformExceptionHandlers() {
    _init_properties_CoroutineExceptionHandlerImpl_kt__37d7wf();
    return get_platformExceptionHandlers_();
  }
  var properties_initialized_CoroutineExceptionHandlerImpl_kt_qhrgvx;
  function _init_properties_CoroutineExceptionHandlerImpl_kt__37d7wf() {
    if (!properties_initialized_CoroutineExceptionHandlerImpl_kt_qhrgvx) {
      properties_initialized_CoroutineExceptionHandlerImpl_kt_qhrgvx = true;
      // Inline function 'kotlin.collections.mutableSetOf' call
      platformExceptionHandlers_ = LinkedHashSet.d1();
    }
  }
  function recoverStackTrace(exception, continuation) {
    return exception;
  }
  function threadContextElements(context) {
    return 0;
  }
  function commonThreadLocal(name) {
    return new CommonThreadLocal();
  }
  //region block: post-declaration
  initMetadataForClass(SchedulerTask, 'SchedulerTask');
  initMetadataForClass(DispatchedTask, 'DispatchedTask');
  initMetadataForClass(CancellableContinuationImpl, 'CancellableContinuationImpl');
  initMetadataForInterface(NotCompleted, 'NotCompleted');
  initMetadataForInterface(CancelHandler, 'CancelHandler', VOID, VOID, [NotCompleted]);
  initMetadataForClass(UserSupplied, 'UserSupplied', VOID, VOID, [CancelHandler]);
  initMetadataForObject(Active, 'Active', VOID, VOID, [NotCompleted]);
  initMetadataForClass(CompletedContinuation, 'CompletedContinuation');
  initMetadataForClass(LockFreeLinkedListNode, 'LockFreeLinkedListNode', LockFreeLinkedListNode);
  initMetadataForInterface(Incomplete, 'Incomplete');
  initMetadataForClass(JobNode, 'JobNode', VOID, VOID, [LockFreeLinkedListNode, Incomplete]);
  initMetadataForClass(ChildContinuation, 'ChildContinuation');
  initMetadataForClass(CompletedExceptionally, 'CompletedExceptionally');
  initMetadataForClass(CancelledContinuation, 'CancelledContinuation');
  initMetadataForObject(Key, 'Key');
  protoOf(CoroutineDispatcher).ec = get;
  initMetadataForClass(CoroutineDispatcher, 'CoroutineDispatcher', VOID, VOID, [AbstractCoroutineContextElement, ContinuationInterceptor]);
  initMetadataForObject(Key_0, 'Key');
  initMetadataForClass(EventLoop, 'EventLoop');
  initMetadataForObject(ThreadLocalEventLoop, 'ThreadLocalEventLoop');
  initMetadataForClass(CompletionHandlerException, 'CompletionHandlerException');
  initMetadataForClass(CoroutinesInternalError, 'CoroutinesInternalError');
  initMetadataForObject(Key_1, 'Key');
  initMetadataForObject(NonDisposableHandle, 'NonDisposableHandle');
  initMetadataForClass(Empty, 'Empty', VOID, VOID, [Incomplete]);
  initMetadataForClass(LockFreeLinkedListHead, 'LockFreeLinkedListHead', LockFreeLinkedListHead);
  initMetadataForClass(NodeList, 'NodeList', NodeList, VOID, [LockFreeLinkedListHead, Incomplete]);
  initMetadataForClass(SynchronizedObject, 'SynchronizedObject');
  initMetadataForClass(Finishing, 'Finishing', VOID, VOID, [SynchronizedObject, Incomplete]);
  initMetadataForClass(JobSupport, 'JobSupport', VOID, VOID, [Element], [0]);
  initMetadataForClass(InactiveNodeList, 'InactiveNodeList', VOID, VOID, [Incomplete]);
  initMetadataForClass(ConcurrentLinkedListNode, 'ConcurrentLinkedListNode');
  initMetadataForClass(Segment, 'Segment', VOID, VOID, [ConcurrentLinkedListNode, NotCompleted]);
  initMetadataForObject(ExceptionSuccessfullyProcessed, 'ExceptionSuccessfullyProcessed');
  initMetadataForClass(DispatchedContinuation, 'DispatchedContinuation');
  initMetadataForClass(DispatchException, 'DispatchException');
  initMetadataForClass(Symbol, 'Symbol');
  initMetadataForClass(UnconfinedEventLoop, 'UnconfinedEventLoop', UnconfinedEventLoop);
  initMetadataForClass(DiagnosticCoroutineContextException, 'DiagnosticCoroutineContextException');
  initMetadataForClass(ListClosed, 'ListClosed');
  initMetadataForClass(CommonThreadLocal, 'CommonThreadLocal', CommonThreadLocal);
  //endregion
  //region block: init
  Active_instance = new Active();
  Key_instance_1 = new Key_0();
  Key_instance_2 = new Key_1();
  NonDisposableHandle_instance = new NonDisposableHandle();
  counter = 0;
  DEBUG = false;
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CancellableContinuationImpl;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./kotlinx-atomicfu.js')));

//# sourceMappingURL=kotlinx-coroutines-core.js.map
